cab50443ffa685d4fedbeb9c0a413d8041c806b2
[grml-autoconfig.git] / autoconfig.functions
1 #!/bin/zsh
2 # Filename:      autoconfig.functions
3 # Purpose:       basic system configuration and hardware setup for grml system
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 ################################################################################
8
9 # {{{ path, variables, signals, umask, zsh
10 export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin"
11 DEBUG="/dev/null"
12 KERNEL="$(uname -r)"
13 ARCH="$(uname -m)"
14 umask 022
15
16 # old linuxrc version:
17 [ -d /cdrom ]      && export LIVECD_PATH=/cdrom
18 # new initramfs layout:
19 [ -d /live/image ] && export LIVECD_PATH=/live/image
20
21 # Ignore these signals in non-interactive mode: INT, TERM, SEGV
22 [ -z "$PS1" ] && trap "" 2 3 11
23
24 # zsh stuff
25 iszsh(){
26 if [ -n "$ZSH_VERSION" ] ; then
27   return 0
28 else
29   return 1
30 fi
31 }
32 # avoid 'no matches found: ...'
33 iszsh && setopt no_nomatch # || echo "Warning: not running under zsh!"
34 # }}}
35
36 # {{{ Read in boot parameters
37 if [ -z "$CMDLINE" ]; then
38   # if CMDLINE was set from the outside, we're debugging.
39   # otherwise, take CMDLINE from Kernel and config files.
40   CMDLINE="$(cat /proc/cmdline)"
41   [ -d /cdrom/bootparams/ ]      && CMDLINE="$CMDLINE $(cat /cdrom/bootparams/* | tr '\n' ' ')"
42   [ -d /live/image/bootparams/ ] && CMDLINE="$CMDLINE $(cat /live/image/bootparams/* | tr '\n' ' ')"
43 fi
44 # }}}
45
46 ### {{{ Utility Functions
47
48 # Get a bootoption's parameter: read boot command line and either
49 # echo last parameter's argument or return false.
50 getbootparam(){
51   local line
52   local ws
53   ws='   '
54   line=" $CMDLINE "
55   case "$line" in
56     *[${ws}]"$1="*)
57       result="${line##*[$ws]$1=}"
58       result="${result%%[$ws]*}"
59       echo "$result"
60       return 0 ;;
61     *) # no match?
62       return 1 ;;
63   esac
64 }
65
66 # Check boot commandline for specified option
67 checkbootparam(){
68   [ -n "$1" ] || ( echo "Error: missing argument to checkbootparam()" ; return 1 )
69   local line
70   local ws
71   ws='   '
72   line=" $CMDLINE "
73   case "$line" in
74     *[${ws}]"$1"=*|*[${ws}]"$1"[${ws}]*)
75       return 0 ;;
76     *)
77       return 1 ;;
78   esac
79 }
80
81 # Check if currently using a framebuffer
82 hasfb() {
83     [ -e /dev/fb0 ] && return 0 || return 1
84 }
85
86 # Check wheter a configuration variable (like $CONFIG_TOHD) is
87 # enabled or not
88 checkvalue(){
89   case "$1" in
90     [yY][eE][sS])     return 0 ;; # it's set to 'yes'
91     [tT][rR][uU][eE]) return 0 ;; # it's set to 'true'
92                    *) return 1 ;; # default
93   esac
94 }
95
96 # Are we using grml-small?
97 checkgrmlsmall(){
98   grep -q small /etc/grml_version 2>>$DEBUG && return 0 || return 1
99 }
100
101 # execute flite only if it's present
102 flitewrapper() {
103    [ -x /usr/bin/flite ] && flite -o play -t "$*"
104 }
105 ### }}}
106
107 # {{{ filesystems (proc, pts, sys) and fixes
108 mount_proc(){
109   [ -f /proc/version ] || mount -t proc /proc /proc 2>/dev/null
110 }
111
112 mount_pts(){
113   grep -q "/dev/pts" /proc/mounts || mount -t devpts /dev/pts /dev/pts 2>/dev/null
114 }
115
116 mount_sys(){
117   [ -d /sys/devices ] || mount -t sysfs /sys /sys 2>/dev/null
118 }
119 # }}}
120
121 # {{{ Check if we are running in live mode or from HD
122 INSTALLED=""
123 [ -e /etc/grml_cd ] || INSTALLED="yes"
124
125 # testcd
126 TESTCD=""
127 checkbootparam 'testcd' >>$DEBUG 2>&1 && TESTCD="yes"
128 # }}}
129
130 # {{{ source lsb-functions , color handling
131 if checkbootparam 'nocolor'; then
132   RC_NOCOLOR=yes
133   . /etc/grml/lsb-functions
134   einfo "Disabling colors in bootsequence as requested on commandline." ; eend 0
135 else
136   . /etc/grml/lsb-functions
137   . /etc/grml_colors
138 fi
139 # }}}
140
141 # {{{ debug
142 config_debug(){
143  checkbootparam 'debug'            && BOOTDEBUG="yes"
144  checkbootparam "BOOT_IMAGE=debug" && BOOTDEBUG="yes"
145
146  rundebugshell(){
147   if [ -n "$BOOTDEBUG" ]; then
148      einfo "Starting intermediate shell stage $stage as requested by \"debug\" option."
149      if [ grep -q "debug=noscreen" "$CMDLINE" ] ; then
150         einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
151         einfo "Just exit the shell to continue boot process..."
152         /bin/zsh
153      else
154         eindent
155         if [ -r /etc/grml/screenrc ] ; then
156            einfo "Starting GNU screen to be able to use a full featured shell environment."
157            einfo "Just exit the shells (and therefore screen) to continue boot process..."
158            /bin/zsh -c "screen -c /etc/grml/screenrc"
159         else
160            einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
161            einfo "Just exit the shell to continue boot process..."
162            /bin/zsh
163         fi
164         eoutdent
165      fi
166   fi
167  }
168 }
169 # }}}
170
171 # {{{ log
172 config_log(){
173 if checkbootparam 'log' || checkbootparam 'debug' ; then
174    export DEBUG="/tmp/grml.log.`date +%Y%m%d`"
175    touch $DEBUG
176    einfo "Bootparameter log found. Log files: ${DEBUG} and /var/log/boot"
177    eindent
178      einfo "Starting bootlogd." # known to be *very* unreliable :(
179      bootlogd -r -c >>$DEBUG 2>&1 ; eend $?
180    eoutdent
181 else
182    DEBUG="/dev/null"
183 fi
184 }
185 # }}}
186
187 # {{{ set firmware timeout via bootparam
188 config_fwtimeout(){
189  if checkbootparam 'fwtimeout' ; then
190    TIMEOUT="$(getbootparam 'fwtimeout' 2>>$DEBUG)"
191    einfo "Bootoption fwtimeout found. (Re)Loading firmware_class module."
192    rmmod firmware_class >>$DEBUG 2>&1
193    modprobe firmware_class ; eend $?
194  fi
195  if [ -z "$TIMEOUT" ] ; then
196    TIMEOUT="100" # linux kernel default: 10
197  fi
198  if [ -f /sys/class/firmware/timeout ] ; then
199    einfo "Setting timeout for firmware loading to ${TIMEOUT}."
200    echo 100 > /sys/class/firmware/timeout ; eend $?
201  fi
202 }
203 # }}}
204
205 ### {{{ language configuration / localization
206 config_language(){
207
208  einfo "Activating language settings:"
209  eindent
210
211  # people can specify $LANGUAGE and $CONSOLEFONT in a config file
212  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
213
214  # check for bootoption which overrides config from /etc/grml/autoconfig
215  BOOT_LANGUAGE="$(getbootparam 'lang' 2>>$DEBUG)"
216  [ -n "$BOOT_LANGUAGE" ] && LANGUAGE="$BOOT_LANGUAGE"
217
218  # set default to 'en' in live-cd mode iff $LANGUAGE is not set yet
219  if [ -z "$INSTALLED" ] ; then
220     [ -n "$LANGUAGE" ] || LANGUAGE='en'
221  fi
222
223  if [ -x /usr/sbin/grml-setlang ] ; then
224    # if bootoption lang is used update /etc/default/locale accordingly
225    if [ -n "$BOOT_LANGUAGE" ] ; then
226      checkgrmlsmall && /usr/sbin/grml-setlang "POSIX" || /usr/sbin/grml-setlang "$LANGUAGE"
227    # otherwise default to lang=en
228    else
229      checkgrmlsmall && /usr/sbin/grml-setlang "POSIX" || /usr/sbin/grml-setlang "en"
230    fi
231  fi
232
233  # set console font
234  if [ -z "$CONSOLEFONT" ] ; then
235     if ! checkbootparam 'nodefaultfont' >>$DEBUG 2>&1 ; then
236        if [ -r /usr/share/consolefonts/Uni3-Terminus16.psf.gz ] ; then
237           CONSOLEFONT='Uni3-Terminus16'
238        else
239           ewarn "/usr/share/consolefonts/Uni3-Terminus16.psf.gz not available. Please upgrade package console-terminus." ; eend 1
240        fi
241        if ! hasfb ; then
242           CONSOLEFONT='Lat15-Terminus16'
243        fi
244     fi
245  fi
246
247  # export it now, so error messages get translated, too
248  if checkgrmlsmall ; then
249     export LANG='C' # grml-small does not provide any further locales
250  else
251     [ -r /etc/default/locale ] && . /etc/default/locale
252     export LANG LANGUAGE
253  fi
254
255  # configure keyboard layout, read in already set values first:
256  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
257
258  # now allow keyboard override by boot commandline for later use:
259  KKEYBOARD="$(getbootparam 'keyboard' 2>>$DEBUG)"
260  [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
261  # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
262  [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
263  [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
264
265  # modify /etc/sysconfig/keyboard only in live-cd mode:
266  if [ -z "$INSTALLED" ] ; then
267
268    local LANGUAGE="$BOOT_LANGUAGE"
269    . /etc/grml/language-functions
270    # allow setting xkeyboard explicitly different than console keyboard
271    KXKEYBOARD="$(getbootparam 'xkeyboard' 2>>$DEBUG)"
272    if [ -n "$KXKEYBOARD" ]; then
273       XKEYBOARD="$KXKEYBOARD"
274       KDEKEYBOARD="$KXKEYBOARD"
275    elif [ -n "$KKEYBOARD" ]; then
276       XKEYBOARD="$KKEYBOARD"
277       KDEKEYBOARD="$KKEYBOARD"
278    fi
279
280    # duplicate of previous code to make sure /etc/grml/language-functions
281    # does not overwrite our values....
282    # now allow keyboard override by boot commandline for later use:
283    KKEYBOARD="$(getbootparam 'keyboard' 2>>$DEBUG)"
284    [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
285    # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
286    [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
287    [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
288
289    # write keyboard related variables to file for later use
290    [ -d /etc/sysconfig ] || mkdir /etc/sysconfig
291    if ! [ -e /etc/sysconfig/keyboard ] ; then
292       echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
293       echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
294       echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
295       echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
296    fi
297  fi
298
299  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
300
301  # activate unicode console if running within utf8 environment
302  if [ -r /etc/default/locale ] ; then
303     if grep -q "LANG=.*UTF" /etc/default/locale ; then
304        einfo "Setting up unicode environment."
305        unicode_start >>$DEBUG 2>&1 ; eend $?
306     fi
307  fi
308
309  # Set default keyboard before interactive setup
310  if [ -n "$KEYTABLE" ] ; then
311     einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
312     loadkeys -q $KEYTABLE &
313     eend $?
314  fi
315
316  # we have to set up all consoles, therefore loop it over all ttys:
317  NUM_CONSOLES=$(fgconsole --next-available 2>/dev/null)
318  if [ -n "$NUM_CONSOLES" ] ; then
319     NUM_CONSOLES=$(expr ${NUM_CONSOLES} - 1)
320     [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
321  fi
322  CUR_CONSOLE=$(fgconsole 2>/dev/null)
323
324  if [ -x "$(which setfont)" ] ; then
325     use_setfont=true
326  elif [ -x "$(which consolechars)" ] ; then
327     use_consolechars=true
328  else
329     eerror "Neither setfont nor consolechars tool present, can not set font."
330     eend 1
331     return 1
332  fi
333
334  if [ -n "$CHARMAP" ] ; then
335     einfo "Setting font to ${CHARMAP}"
336     RC=0
337     for vc in $(seq 0 ${NUM_CONSOLES}) ; do
338         if $use_setfont ; then
339           setfont -C /dev/tty${vc} $CHARMAP ; RC=$?
340         elif $use_consolechars ; then
341           consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
342         fi
343     done
344     if [ -n "$CUR_CONSOLE" ] ; then
345        [ "$CUR_CONSOLE" != "serial" ] && chvt $CUR_CONSOLE
346     fi
347     eend $RC
348  fi
349
350  if checkbootparam 'noconsolefont' ; then
351     ewarn "Skipping setting console font as requested on boot commandline." ; eend 0
352  else
353     if [ -n "$CONSOLEFONT" ] ; then
354        einfo "Setting font to ${CONSOLEFONT}"
355        RC=0
356        for vc in $(seq 0 ${NUM_CONSOLES}) ; do
357            if $use_setfont ; then
358              setfont -C /dev/tty${vc} ${CONSOLEFONT} ; RC=$?
359            elif $use_consolechars ; then
360              consolechars --tty=/dev/tty${vc} -f ${CONSOLEFONT} ; RC=$?
361            fi
362        done
363        if [ -n "$CUR_CONSOLE" ] ; then
364           [ "$CUR_CONSOLE" != "serial" ] && chvt $CUR_CONSOLE
365        fi
366        eend $RC
367     fi
368  fi
369
370  eoutdent
371 }
372 # }}}
373
374 # {{{ Set hostname
375 config_hostname(){
376  if checkbootparam 'hostname' ; then
377   HOSTNAME="$(getbootparam 'hostname' 2>>$DEBUG)"
378   if [ -z "$HOSTNAME" ] && [ -x /usr/bin/random-hostname ] ; then
379      einfo "Generating random hostname as no hostname was specified."
380      HOSTNAME="$(/usr/bin/random-hostname)"
381      eend $?
382   fi
383   einfo "Setting hostname to $HOSTNAME as requested."
384   grml-hostname $HOSTNAME >>$DEBUG ; RC=$?
385   [ "$RC" = "0" ] && hostname $HOSTNAME
386   eend $RC
387  else
388   hostname --file /etc/hostname
389  fi
390 }
391 # }}}
392
393 # fstabuser (needed when running from harddisk with username != grml {{{
394 config_userfstab(){
395   [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
396   if [ -n "$CONFIG_FSTAB_USER" ] ; then
397      fstabuser="$CONFIG_FSTAB_USER"
398   else
399      fstabuser=$(getent passwd 1000 | cut -d: -f1)
400   fi
401   # if not yet set fall back to default 'grml' user
402   [ -n "$fstabuser" ] || fstabuser='grml'
403 }
404 # }}}
405
406 # {{{ Set clock (Local time is more often used than GMT, so it is default)
407 config_time(){
408  # don't touch the files if running from harddisk:
409  if [ -z "$INSTALLED" ]; then
410     # The default hardware clock timezone is stated as representing local time.
411     UTC="--localtime"
412     grep -q "^UTC=" /etc/default/rcS || echo "UTC=no" >> /etc/default/rcS
413     checkbootparam 'utc'       >>$DEBUG 2>&1 && sed -i "s|^UTC=.*$|UTC=yes|" /etc/default/rcS
414     checkbootparam 'gmt'       >>$DEBUG 2>&1 && sed -i "s|^UTC=.*$|UTC=yes|" /etc/default/rcS
415     checkbootparam 'localtime' >>$DEBUG 2>&1 && sed -i "s|^UTC=.*$|UTC=no|"  /etc/default/rcS
416     grep -q -i "^UTC=yes" /etc/default/rcS && UTC="-u"
417     # hwclock uses the TZ variable
418     KTZ="$(getbootparam 'tz' 2>>$DEBUG)"
419     [ -z "$KTZ" ] && [ -r /etc/timezone ] && KTZ=$(cat /etc/timezone)
420     if [ ! -f "/usr/share/zoneinfo/$KTZ" ] ; then
421        ewarn "Warning: unknown timezone $KTZ" ; eend 1
422        KTZ="Europe/Vienna"
423        ewarn "Falling back to timezone $KTZ" ; eend 0
424     fi
425
426     if ! [ -r /dev/rtc ] ; then
427       ewarn "Warning: realtime clock not available, trying to execute hwclock anyway." ; eend 0
428     fi
429
430     ERROR=$(TZ="$KTZ" hwclock $UTC -s 2>&1 | head -1) ; RC=$?
431     if [ -n "$ERROR" ] ; then
432        eindent
433        ERROR=$(TZ="$KTZ" hwclock $UTC -s --directisa 2>&1 | head -1)
434        if [ -n "$ERROR" ] ; then
435           eerror "Problem running hwclock: $ERROR" ; eend 1
436        fi
437        eoutdent
438     fi
439
440  fi
441 }
442 # }}}
443
444 # {{{ print kernel info
445 config_kernel(){
446   vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMware/Qemu${NORMAL}"
447   [ -d /proc/xen ] && VMWARE='' # vmware-detect returns '0' when running with a Xen-enabled kernel
448   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
449   if [ -r /proc/cpuinfo ] ; then
450      if egrep -q '^flags.*(vmx|svm)' /proc/cpuinfo ; then
451        eindent
452        einfo 'CPU(s) featuring virtualization technology detected' ; eend 0
453        eoutdent
454      fi
455   fi
456   if [ -d /proc/xen ] ; then
457      eindent
458      einfo 'Running kernel featuring support for Xen detected' ; eend 0
459      eoutdent
460   fi
461 }
462 # }}}
463
464 # {{{ vmware specific stuff
465 config_vmware(){
466 if checkbootparam 'novmware' ; then
467    ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
468 else
469    if [ -z "$INSTALLED" ] ; then
470       if vmware-detect || checkbootparam "BOOT_IMAGE=vmware" ; then
471          if ! checkbootparam 'qemu' ; then
472             if [ -r /etc/X11/xorg.conf.vmware ] ; then
473                einfo "VMware: Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
474                cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
475             fi
476          fi
477       elif [ -r /proc/acpi/battery/BAT0/info -a -r /etc/X11/xorg.conf.virtualbox ] ; then
478          if grep -q 'OEM info:                innotek' /proc/acpi/battery/BAT0/info ; then
479             einfo 'Virtual Box: Copying /etc/X11/xorg.conf.virtualbox to /etc/X11/xorg.conf'
480             cp /etc/X11/xorg.conf.virtualbox /etc/X11/xorg.conf ; eend $?
481          fi
482       fi
483    fi
484 fi
485 }
486 # }}}
487
488 # {{{ qemu specific stuff
489 config_qemu(){
490 if checkbootparam 'qemu' ; then
491    if [ -r /etc/X11/xorg.conf.example ] ; then
492       einfo "Qemu: Copying /etc/X11/xorg.conf.example to /etc/X11/xorg.conf"
493       cp /etc/X11/xorg.conf.example /etc/X11/xorg.conf ; eend $?
494    fi
495 fi
496 }
497 # }}}
498
499 # {{{ ld.so.cache + depmod
500 config_ld_mod(){
501 if [ -n "$INSTALLED" ]; then
502  if ! [ -r /etc/grml.first.boot ] ; then
503   einfo "Running from HD for the first time, regenerate ld.so.cache and modules.dep:"
504   eindent
505 # Regenerate ld.so.cache and module dependencies on HD
506     einfo "Running ldconfig" ; ldconfig  ; eend $?
507     einfo "Running depmod"   ; depmod -a ; eend $?
508     touch /etc/grml.first.boot
509     eend 0
510   eoutdent
511  fi
512 fi
513 }
514 # }}}
515
516 # {{{ timezone
517 config_timezone(){
518  # don't touch the files if running from harddisk:
519  if [ -z "$INSTALLED" ]; then
520     KTZ="$(getbootparam 'tz' 2>>$DEBUG)"
521     if [ -n "$KTZ" ] ; then
522        if [ ! -f "/usr/share/zoneinfo/$KTZ" ]
523        then
524           ewarn "Warning: unknown timezone $KTZ"; eend 0
525        else
526           einfo "Setting timezone."
527           # update debconf
528           area=$(echo $KTZ | cut -d '/' -f1)
529           zone=$(echo $KTZ | cut -d '/' -f2)
530           echo "tzdata tzdata/Areas       select $area" | debconf-set-selections
531           echo "tzdata tzdata/Zones/$area select $zone" | debconf-set-selections
532           # update files
533           echo $KTZ > /etc/timezone
534           rm -f /etc/localtime
535           cp "/usr/share/zoneinfo/$KTZ" /etc/localtime ; eend $?
536        fi
537     fi
538  fi
539 }
540 # }}}
541
542 # small computer / nearly no ram {{{
543 config_small(){
544
545 RAM=$(/usr/bin/gawk '/MemTotal/{print $2}' /proc/meminfo)
546 # MEM=$(/usr/bin/gawk 'BEGIN{m=0};/MemFree|Cached|SwapFree/{m+=$2};END{print m}' /proc/meminfo)
547 eindent
548
549 if checkbootparam 'small'; then
550   einfo "Information: ${RAM} kB of RAM available." ; eend 0
551   einfo "Bootoption small detected. Activating small system."
552   if [ -r /etc/inittab.small ] ; then
553     mv /etc/inittab /etc/inittab.normal
554     mv /etc/inittab.small /etc/inittab
555   else
556     sed -i 's/^9/#&/' /etc/inittab
557     sed -i 's/^10/#&/' /etc/inittab
558     sed -i 's/^11/#&/' /etc/inittab
559     sed -i 's/^12/#&/' /etc/inittab
560   fi
561   /sbin/telinit q ; eend $?
562 else
563   if checkgrmlsmall ; then
564     if [[ $RAM -lt 25000 ]] ; then
565       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
566       ewarn "At least 32MB of RAM should be available for grml-small." ; eend 1
567       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
568       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
569       /bin/zsh --login
570     else
571       einfo "Information: ${RAM} kB of RAM available." ; eend 0
572     fi
573   else
574     if [[ $RAM -lt 58000 ]] ; then
575       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
576       ewarn "At least 64MB of RAM should be available for grml." ; eend 1
577       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
578       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
579       /bin/zsh --login
580     else
581       einfo "Information: ${RAM} kB of RAM available." ; eend 0
582     fi
583   fi
584 fi
585 eoutdent
586 }
587 # }}}
588
589 # skip startup of w3m {{{
590 config_fast(){
591 if checkbootparam 'fast'; then
592   ewarn "Bootoption fast detected. Skipping startup of grml-quickconfig."
593     sed -i 's#^1:.*#1:12345:respawn:/usr/bin/openvt -f -c 1 -w -- /bin/zsh#' /etc/inittab
594   /sbin/telinit q ; eend $?
595 fi
596 }
597 # }}}
598
599 # activate serial console {{{
600 config_console(){
601 if checkbootparam 'console'; then
602   local line
603   local ws
604   ws='   '
605
606   einfo "Bootoption for serial console detected:"
607
608   line="$CMDLINE x "
609   this=""
610   line="${line#*[$ws]}"
611   local telinitq=""
612   while [ -n "$line" ]; do
613     case "$this" in
614       console=*)
615         local serial="$this"
616         local device="${this%%,*}"
617         local device="${device##*=}"
618         if echo $serial | grep -q ttyS ; then
619           local option="${serial##*,}"
620           # default (works for kvm & CO):
621           local speed="115200,57600,38400,19200,9600,4800,2400,1200";
622           # ... unless overriden by command line:
623           case "$option" in
624             115200*) speed=115200 ;;
625              57600*) speed=57600 ;;
626              38400*) speed=38400 ;;
627              19200*) speed=19200 ;;
628               9600*) speed=9600 ;;
629               4800*) speed=4800 ;;
630               2400*) speed=2400 ;;
631               1200*) speed=1200 ;;
632           esac
633           eindent
634             einfo "Activating console login on device ${device} with speed ${speed}."
635             local number="${device#ttyS}"
636             sed -i "/^T$number:/d;/^#grmlserial#/iT$number:23:respawn:/bin/bash -c \"/sbin/getty -L $device -l /usr/bin/zsh-login $speed vt100 || sleep 30\"" /etc/inittab
637             eend $?
638             telinitq="1"
639           eoutdent
640         fi
641         ;;
642     esac
643     this="${line%%[$ws]*}"
644     line="${line#*[$ws]}"
645   done
646
647   if [ -n "$telinitq" ]; then
648     /sbin/telinit q
649   fi
650   eend $?
651 fi
652 }
653 # }}}
654
655 # For burning on IDE-CD-Roms, k3b (and others) check for special permissions {{{
656 config_cdrom_perm(){
657 CDROMS=""
658 for DEVICE in /proc/ide/hd?; do
659  [ "$(cat $DEVICE/media 2>/dev/null)" = "cdrom" ] && CDROMS="$CDROMS /dev/${DEVICE##*/}"
660 done
661 [ -n "$CDROMS" ] && { chown root.cdrom $CDROMS; chmod 666 $CDROMS; } 2>/dev/null
662 }
663 # }}}
664
665 # {{{ Bring up loopback interface now
666 config_local_net(){
667  if [ -z "$INSTALLED" ] ; then
668     if grep -q 'iface lo inet loopback' /etc/network/interfaces 2>/dev/null ; then
669        grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
670     else
671        ifconfig lo up
672     fi
673  fi
674 }
675 # }}}
676
677 # firewire devices {{{
678 # the raw1394 driver does not yet export info into SYSFS,
679 # so let's create raw1394 device manually
680 # http://www.michael-prokop.at/blog/index.php?p=352
681 config_firewire_dev(){
682 if checkbootparam 'nofirewiredev' ; then
683   ewarn "Skipping creating some firewire devices as requested on boot commandline." ; eend 0
684 else
685 #if [ "${KERNEL%-*}" == "2.6.11" ] ; then
686   einfo "Creating some firewire devices (fix kernel 2.6-bug)."
687 #  cd /dev && MAKEDEV video1394 raw1394
688   [ -r /dev/raw1394 ]   || mknod /dev/raw1394 c 171 0
689   [ -r /dev/video1394 ] || mknod -m 666 /dev/video1394 c 171 16
690 # mknod -m 666 /dev/dv1394 c 171 32 # for NTSC
691   [ -r /dev/dv1394 ]    || mknod -m 666 /dev/dv1394 c 171 34 # for PAL
692   chown -R root:video /dev/raw1394 /dev/video1394 /dev/dv1394
693   chmod -R 664 /dev/raw1394 /dev/video1394 /dev/dv1394 ; eend $?
694 fi
695 #fi
696 }
697 # }}}
698
699 # {{{ copy passwd-lockfile to ramdisk (fix unionfs-behaviour)
700 # otherwise we will get: passwd: Authentication token lock busy
701 config_fix_passwd(){
702  if [ -z "$INSTALLED" ] ; then
703   touch /etc/.pwd.lock
704  fi
705 }
706 # }}}
707
708 # {{{ CD Checker
709 config_testcd(){
710 if [ -n "$TESTCD" ]; then
711    einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
712    einfo "Reading files and checking against GRML/md5sums, this may take a while..."
713    echo -n "${RED}"
714
715    if [ -n "${LIVECD_PATH}"/GRML ] ; then
716       ( cd "${LIVECD_PATH}"/GRML ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log ; RC=$? )
717    else
718       echo "${RED} *** Error: Could not find md5sum file.                           ***"
719    fi
720
721    if [ "$RC" = "0" ]; then
722       einfo "Everything looks OK" ; eend 0
723    else
724       eerror 'Checksum failed for theses files:' ; eend 1
725       egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
726       eerror 'Data on the grml medium is possibly incomplete/damaged or...'
727       eerror '... RAM of your computer is broken.' ; eend 1
728       einfon "Hit return to continue, or press the reset button to quit."
729      read a
730    fi
731
732    eend 0
733 fi
734 }
735 # }}}
736
737 # {{{ hardware detection via discover
738 config_discover(){
739 if checkbootparam 'nodisc' ; then
740   ewarn "Skipping hardware detection via discover as requested on boot commandline." ; eend 0
741 else
742  if [ -x /sbin/discover ] ; then
743   einfo "Discovering hardware. Trying to load the following modules in background:"
744    eindent
745    einfo "$(discover --data-path=linux/module/name --data-path=linux/modules/options --format="%s %s" --data-version=`uname -r` --enable-bus all | sort -u | xargs echo)"
746    eoutdent
747   /sbin/discover-modprobe -v >>$DEBUG 2>&1 &
748   eend 0
749  else
750   eerror "Application discover not available. Information: udev should handle hardware recognition." ; eend 0
751  fi
752 fi
753 }
754 # }}}
755
756 # {{{ hardware detection via hwinfo
757 config_hwinfo(){
758 if checkbootparam 'hwinfo' >>$DEBUG 2>&1; then
759   einfo "Discovering hardware via hwinfo:"
760   MODULES=$(su grml hwinfo | grep "Cmd: \"modprobe" | awk '{print $5}' | sed 's/"//')
761   echo -n "  Loading modules: "
762   for i in `echo $MODULES` ; do echo -n $i && modprobe $i ; done
763   eend 0
764 fi
765 }
766 # }}}
767
768 # {{{ disable hotplug agents on request
769 config_hotplug_agent(){
770 if checkbootparam 'noagent' ; then
771   AGENT="$(getbootparam 'noagent' 2>>$DEBUG)"
772   AGENTLIST=$(echo "$AGENT" | sed 's/,/\\n/g')
773   AGENTNL=$(echo "$AGENT" | sed 's/,/ /g')
774   einfo "Disabling hotplug-agent(s) $AGENTNL"
775   for agent in $(echo -e $AGENTLIST) ; do
776     mv /etc/hotplug/${agent}.rc /etc/hotplug/${agent}.norc
777   done
778   [ "$?" == "0" ] ; eend $?
779 fi
780 }
781 # }}}
782
783 # {{{ blacklist of hotplug-modules
784 config_hotplug_blacklist(){
785 if checkbootparam 'black' ; then
786   BLACK="$(getbootparam 'black' 2>>$DEBUG)"
787   BLACKLIST=$(echo "$BLACK" | sed 's/,/\\n/g')
788   BLACKNL=$(echo "$BLACK" | sed 's/,/ /g')
789   einfo "Blacklisting $BLACKNL via /etc/hotplug/blacklist.d/hotplug-light"
790   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist.d/hotplug-light
791   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist
792   eend 0
793 fi
794 }
795 # }}}
796
797 # {{{ run hotplug
798 config_hotplug(){
799 if checkbootparam 'nohotplug' ; then
800   ewarn "Skipping running hotplug as requested on boot commandline." ; eend 0
801 else
802   if [ -r /etc/init.d/hotplug ] ; then
803     einfo "Starting hotplug system in background."
804     /etc/init.d/hotplug start >>$DEBUG 2>>$DEBUG &
805     eend 0
806   elif [ -r /etc/init.d/hotplug-light ] ; then
807     einfo "Starting hotplug-light system in background."
808     /etc/init.d/hotplug-light start >>$DEBUG 2>>$DEBUG &
809     eend 0
810   else
811     ewarn "No hotplug system found. Should be handled by udev. Skipping execution." ; eend 0
812   fi
813 fi
814 }
815 # }}}
816
817 # {{{ blacklist specific module [ used in /etc/init.d/udev ]
818 config_blacklist(){
819 if checkbootparam 'blacklist' ; then
820  if [ -z "$INSTALLED" ]; then
821   einfo "Bootoption blacklist found."
822   BLACK="$(getbootparam 'blacklist' 2>>$DEBUG)"
823   BLACKLIST_FILE='/etc/modprobe.d/grml.conf'
824   if [ -n "$BLACK" ] ; then
825     for module in $(echo ${BLACK//,/ }) ; do
826         einfo "Blacklisting module ${module} via ${BLACKLIST_FILE}."
827         echo "# begin entry generated by config_blacklist of grml-autoconfig" >> "$BLACKLIST_FILE"
828         echo "blacklist $module"     >> "$BLACKLIST_FILE"
829         echo "alias     $module off" >> "$BLACKLIST_FILE"
830         echo "# end   entry generated by config_blacklist of grml-autoconfig" >> "$BLACKLIST_FILE" ; eend $?
831     done
832   else
833    eerror "No given module for blacklist found. Blacklisting will not work therefore."
834   fi
835  else
836   ewarn "Backlisting via bootoption is not intended for use on harddisk installations." ; eend 1
837   eindent
838    einfo "Please blacklist the module(s) manually using the 'blacklist' script."
839   eoutdent
840  fi
841 fi
842 }
843 # }}}
844
845 # {{{ ACPI
846 config_acpi_apm(){
847 if [ -d /proc/acpi ]; then
848   if checkbootparam 'noacpi'; then
849     ewarn "Skipping ACPI Bios detection as requested via noacpi on boot commandline." ; eend 0
850   elif checkbootparam 'nogrmlacpi' ; then
851     ewarn "Skipping ACPI Bios detection as requested via nogrmlacpi on boot commandline." ; eend 0
852   else
853     einfo "ACPI Bios found, activating modules (disable via bootoption noacpi / nogrmlacpi): "
854     eindent
855     found=""
856     for a in /lib/modules/$KERNEL/kernel/drivers/acpi/*; do
857       basename="${a##*/}"
858       basename="${basename%%.*}"
859       case "$basename" in *_acpi)
860        egrep -qi "${basename%%_acpi}" /proc/acpi/dsdt 2>>$DEBUG || continue ;;
861       esac
862       modprobe $basename >>$DEBUG 2>&1 && found="yes"
863       local BASE="$BASE $basename"
864     done
865     if [ -n "$found" ] ; then
866       einfo "$BASE"  ; eend 0
867     else
868       ewarn "(none)" ; eend 1
869     fi
870     if ! ps x | grep -q /usr/sbin/acpid ; then
871       if ! [ -r /var/run/dbus/pid ] ; then
872         einfo "Starting acpi daemon."
873         /etc/init.d/acpid start >>$DEBUG 2>&1 ; eend $?
874       else
875         eerror "acpid error: it seems you are running d-bus/hal, but acpid needs to be started before d-bus."
876         eerror "Solution: please activate acpid via /etc/runlevel.conf"
877         eend 1
878       fi
879     else
880       ewarn "acpi daemon already running."
881       eend 0
882     fi
883     eoutdent
884   fi
885 else
886 # APM
887   if checkbootparam 'noapm'; then
888     ewarn "Skipping APM Bios detection as requested on boot commandline." ; eend 0
889   else
890     modprobe apm power_off=1 >>$DEBUG 2>&1
891     if [ "$?" = "0" ] ; then
892        if [ -x /etc/init.d/apmd ] ;then
893           einfo "APM Bios found, enabling power management functions."
894           /etc/init.d/apmd start ; eend $?
895        fi
896     else
897       eerror "Loading apm module failed." ; eend 1
898     fi
899   fi
900 fi
901 }
902 # }}}
903
904 # {{{ PCMCIA Check/Setup
905 # This needs to be done before other modules are being loaded (by hwsetup)
906 config_pcmcia(){
907 if checkbootparam 'nopcmcia'; then
908   ewarn "Skipping PCMCIA detection as requested on boot commandline." ; eend 0
909 else
910   if /usr/sbin/laptop-detect ; then
911     einfo "Detected Laptop - checking for PCMCIA." && eend 0
912     modprobe pcmcia_core >>$DEBUG 2>&1
913     # Try Cardbus or normal PCMCIA socket drivers
914     modprobe yenta_socket >>$DEBUG 2>&1 || modprobe i82365 >>$DEBUG 2>&1 || modprobe pd6729 >>$DEBUG 2>&1 || modprobe tcic >>$DEBUG 2>&1
915     if [ "$?" = "0" ]; then
916       modprobe ds >>$DEBUG 2>&1
917       if [ -d /proc/bus/pccard ] ; then
918        if [ -x /sbin/cardmgr ] ; then
919         einfo "PCMCIA found, starting cardmgr."
920         cardmgr >>$DEBUG 2>&1 && sleep 6 && eend 0
921        else
922         eerror "No cardmgr found. Make sure package pcmciautils is installed, it should handle it instead." ; eend 1
923        fi
924       fi
925     fi
926   fi
927 fi
928 }
929 # }}}
930
931 # {{{ run software synthesizer via speakup
932 config_swspeak(){
933    if checkbootparam 'swspeak' ; then
934       einfo "Bootoption swspeak found."
935
936       if [ ! -d /proc/speakup/ ] && ! grep -q speakup_soft /proc/modules ; then
937          ewarn "Kernel does not support software speakup - trying to load kernel module:" ; eend 0
938          eindent
939          einfo "Loading speakup_soft"
940          if modprobe speakup_soft ; then
941             eend 0
942          else
943             flitewrapper "Fatal error setting up software speakup"
944             eend 1
945             return 1
946          fi
947          eoutdent
948       fi
949
950       if [ -d /proc/speakup/ ] || grep -q speakup_soft /proc/modules ; then
951          einfo "Kernel supports speakup." ; eend 0
952          eindent
953             einfo "Just run swspeak if you want to use software synthesizer via speakup."
954             flitewrapper "Finished activating software speakup. Just run swspeak when booting finished."
955          eoutdent
956       else
957          eerror "Kernel does not seem to support speakup. Skipping swspeak." ; eend 1
958          flitewrapper "Kernel does not seem to support speakup. Sorry."
959       fi
960    fi
961 }
962 # }}}
963
964 # {{{ support hardware synthesizer via speakup
965 config_hwspeak(){
966    if checkbootparam 'speakup.synth' ; then
967       einfo "Bootoption speakup.synth found."
968       eindent
969
970       module="$(getbootparam 'speakup.synth' 2>>$DEBUG)"
971       if [ -z "$module" ] ; then
972          eerror "Sorry, no speakup module specified for bootoption speakup.synth."
973          flitewrapper "Sorry, no speakup module specified for bootoption speakup.synth."
974       else
975          einfo "Trying to load $module"
976          modprobe "speakup_${module}"
977          eend $?
978       fi
979
980       if [ -d /proc/speakup/ ] || grep -q speakup /proc/modules ; then
981          einfo "Kernel should support speakup now." ; eend 0
982          flitewrapper "Kernel should support speakup now."
983       else
984          eerror "Kernel or hardware do not seem to support speakup. Skipping hwspeak." ; eend 1
985          flitewrapper "Kernel or hardware do not seem to support speakup. Sorry."
986       fi
987
988       eoutdent
989
990    # hwspeak:
991    elif checkbootparam 'hwspeak' ; then
992       einfo "Bootoption hwspeak found."
993
994       if [ ! -d /proc/speakup/ ] && ! grep -q speakup /proc/modules ; then
995          ewarn "Kernel does not support hardware speakup - trying to load kernel modules:" ; eend 0
996          eindent
997          if ! [ -d "/lib/modules/${KERNEL}/extra/speakup/" ] ; then
998             eerror "Kernel does not provide speakup modules, sorry." ; eend 1
999          else
1000            for module in $(find "/lib/modules/${KERNEL}/extra/speakup/" -name \*.ko | \
1001                            sed 's#.*speakup/##g ; s#.ko$##g' | \
1002                            grep -ve speakup_soft -ve speakup_dummy | sort -u) ; do
1003               einfo "Trying to load $module"
1004               modprobe $module
1005               eend $?
1006            done
1007          fi
1008          eoutdent
1009       fi
1010
1011       if [ -d /proc/speakup/ ] || grep -q speakup /proc/modules ; then
1012          einfo "Kernel should support speakup now." ; eend 0
1013          flitewrapper "Kernel should support speakup now."
1014       else
1015          eerror "Kernel or hardware do not seem to support speakup. Skipping hwspeak." ; eend 1
1016          flitewrapper "Kernel or hardware do not seem to support speakup. Sorry."
1017       fi
1018    fi
1019 }
1020 # }}}
1021
1022 # {{{ Check for blind option or brltty
1023 config_blind(){
1024 BLIND=""
1025 checkbootparam 'blind' && BLIND="yes"
1026 BRLTTY="$(getbootparam 'brltty' 2>>$DEBUG)"
1027
1028 if [ -n "$BLIND" -o -n "$BRLTTY" ]; then
1029   if [ -x /sbin/brltty ]; then
1030     # Blind option detected, start brltty now.
1031     # modprobe serial_core parport_serial generic_serial && echo "done"
1032     CMD=brltty
1033     BRLTYPE=""
1034     BRLDEV=""
1035     BRLTEXT=""
1036     if [ -n "$BRLTTY" ]; then
1037       # Extra options
1038       BRLTYPE="${BRLTTY%%,*}"
1039       R="${BRLTTY#*,}"
1040       if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
1041         BRLTTY="$R"
1042         BRLDEV="${BRLTTY%%,*}"
1043         R="${BRLTTY#*,}"
1044         if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
1045           BRLTTY="$R"
1046           BRLTEXT="${BRLTTY%%,*}"
1047           R="${BRLTTY#*,}"
1048         fi
1049       fi
1050     fi
1051     [ -n "$BRLTYPE" ] && CMD="$CMD -b $BRLTYPE"
1052     [ -n "$BRLDEV"  ] && CMD="$CMD -d $BRLDEV"
1053     [ -n "$BRLTEXT" ] && CMD="$CMD -t $BRLTEXT"
1054     einfo "Starting braille-display manager."
1055 #    ( exec $CMD & )
1056     ( sh -c "$CMD" & )
1057     sleep 2 && BLINDSOUND="yes"
1058     eend 0
1059   fi
1060 fi
1061 }
1062 # }}}
1063
1064 # {{{ Interactive configuration
1065 config_interactive(){
1066   ewarn "config_interactive is deprecated nowadays."
1067   ewarn "Please set CONFIG_INTERACTIVE='no' in /etc/grml/autoconfig" ; eend 0
1068 }
1069 # }}}
1070
1071 # {{{ AGP
1072 config_agp(){
1073 if checkbootparam 'forceagp' ; then
1074 # Probe for AGP. Hope this can fail safely
1075   grep -q "AGP" "/proc/pci" 2>>$DEBUG && { modprobe agpgart || modprobe agpgart agp_try_unsupported=1; } >>$DEBUG 2>&1 && einfo "AGP bridge detected." ; eend 0
1076 fi
1077 }
1078 # }}}
1079
1080 # {{{ automount(er)
1081 config_automounter(){
1082 if checkbootparam 'automounter' ; then
1083   RUNLEVEL="$(runlevel)"
1084   AUTOMOUNTER=""
1085   [ -x /etc/init.d/autofs ] && [ "$RUNLEVEL" != "N 1" ] && [ "$RUNLEVEL" != "N S" ] && AUTOMOUNTER="yes"
1086
1087 addautomount(){
1088 # /dev/ice  options
1089   d="${1##*/}"
1090   if [ -n "$AUTOMOUNTER" ]; then
1091     [ -d "/mnt/$d" -a ! -L "/mnt/$d" ] && rmdir /mnt/$d
1092     [ -d "/mnt/auto/$d" ] || mkdir -p "/mnt/auto/$d"
1093     [ -L "/mnt/$d" ]      || ln -s "/mnt/auto/$d" "/mnt/$d"
1094     anew="$d        -fstype=auto,$2 :$i"
1095     grep -q "$anew" "/etc/auto.mnt" || echo "$anew" >> /etc/auto.mnt
1096     AUTOMOUNTS="$AUTOMOUNTS $d"
1097     new="$1 /mnt/auto/$d  auto   users,noauto,exec,$2 0 0"
1098   else
1099     [ -d /mnt/$d ] && mkdir -p /mnt/$d
1100     new="$1 /mnt/$d  auto   users,noauto,exec,$2 0 0"
1101   fi
1102   grep -q "$new" "/etc/fstab" || echo "$new" >> /etc/fstab
1103 }
1104
1105   AUTOMOUNTS="floppy cdrom"
1106 # Add new devices to /etc/fstab and /etc/auto.mnt
1107   for i in /dev/cdrom?*; do
1108     if [ -L $i ]; then
1109       addautomount "$i" "ro"
1110     fi
1111   done
1112 fi
1113
1114 if [ -n "$AUTOMOUNTER" ]; then
1115 # Check for floppy dir, reinstall with automounter
1116   [ -d /mnt/floppy -a ! -L /mnt/floppy ] && rmdir /mnt/floppy
1117   [ -d /mnt/auto/floppy ] || mkdir -p /mnt/auto/floppy
1118   [ -L /mnt/floppy ] || ln -s /mnt/auto/floppy /mnt/floppy
1119   [ -d /mnt/cdrom -a ! -L /mnt/cdrom ] && rmdir /mnt/cdrom
1120   [ -d /mnt/auto/cdrom ] || mkdir -p /mnt/auto/cdrom
1121   [ -L /mnt/cdrom ] || ln -s /mnt/auto/cdrom /mnt/cdrom
1122   rm -f /etc/fstab.new
1123 # Replace paths from bootfloppy
1124   sed 's|/mnt/cdrom|/mnt/auto/cdrom|g;s|/mnt/floppy|/mnt/auto/floppy|g' /etc/fstab > /etc/fstab.new
1125   mv -f /etc/fstab.new /etc/fstab
1126 # Start automounter now
1127   einfo "Starting automounter for ${AUTOMOUNTS}."
1128   /etc/init.d/autofs start >>$DEBUG ; eend $?
1129 fi
1130 }
1131 # }}}
1132
1133 # {{{ Collect partitions from /proc/partitions first for enabling DMA
1134 check_partitions(){
1135 partitions=""
1136 IDEDISKS=""
1137 while read major minor blocks partition relax; do
1138   partition="${partition##*/}"
1139   [ -z "$partition" -o ! -e "/dev/$partition" ] && continue
1140   case "$partition" in
1141     hd?) IDEDISKS="$IDEDISKS $partition";;                # IDE  Harddisk, entire disk
1142     sd?) ;;                                               # SCSI Harddisk, entire disk
1143 #    [hs]d*) partitions="$partitions /dev/$partition";;    # IDE or SCSI disk partition
1144     [hs]d*|ub*) partitions="$partitions /dev/$partition";;    # IDE, USB or SCSI disk partition
1145   esac
1146 done <<EOT
1147 $(awk 'BEGIN{old="__start"}{if($0==old){exit}else{old=$0;if($4&&$4!="name"){print $0}}}' /proc/partitions)
1148 EOT
1149 }
1150 check_partitions >/dev/null 2>&1 # avoid output "check_partitions:3: read-only file system"
1151 # }}}
1152
1153 # {{{ Enable DMA for all IDE drives now if not disabled
1154 # Notice: Already done by linuxrc, but make sure it's done also on harddisk-installed systems
1155 config_dma(){
1156 if checkbootparam 'nodma'; then
1157   ewarn "Skipping DMA accelleration as requested on boot commandline." ; eend 0
1158 else
1159   for d in $(cd /proc/ide 2>>$DEBUG && echo hd[a-z]); do
1160     if test -d /proc/ide/$d; then
1161       if egrep -q 'using_dma[ \t]+0' /proc/ide/$d/settings 2>>$DEBUG; then
1162         MODEL="$(cat /proc/ide/$d/model 2>>$DEBUG)"
1163         test -z "$MODEL" && MODEL="[GENERIC IDE DEVICE]"
1164         einfo "Enabling DMA acceleration for: ${WHITE}$d        ${YELLOW}[${MODEL}]${NORMAL}"
1165         echo "using_dma:1" >/proc/ide/$d/settings
1166         eend 0
1167       fi
1168     fi
1169   done
1170 fi
1171 }
1172 # }}}
1173
1174 # {{{ Start creating /etc/fstab with HD partitions and USB SCSI devices now
1175 config_fstab(){
1176
1177 NOSWAP="yes" # we do not use swap by default!
1178 if checkbootparam 'swap' || checkbootparam 'anyswap' ; then
1179    NOSWAP=''
1180    checkbootparam 'anyswap' && export ANYSWAP='yes' || export ANYSWAP=""
1181 fi
1182
1183 if checkbootparam 'nofstab' || checkbootparam 'forensic' ; then
1184   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
1185 else
1186   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
1187   iszsh && setopt nonomatch
1188   if [ -x /usr/sbin/rebuildfstab ] ; then
1189      config_userfstab || fstabuser=grml
1190      /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
1191   else
1192      ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
1193   fi
1194 fi # checkbootparam nofstab/forensic
1195
1196 # Scan for swap, config, homedir - but only in live-mode
1197 if [ -z "$INSTALLED" ] ; then
1198    [ -z "$NOSWAP" ] && einfo "Searching for swap partition(s) as requested."
1199    GRML_IMG=""
1200    GRML_SWP=""
1201    HOMEDIR="$(getbootparam 'home')"
1202    if [ -n "$partitions" ]; then
1203       while read p m f relax; do
1204         case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
1205         partoptions="users,exec"
1206         fnew=""
1207         # it's a swap partition?
1208         case "$f" in swap)
1209           eindent
1210           if [ -n "$NOSWAP" ]; then
1211              ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)"
1212              eend 0
1213           else
1214              case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
1215                    S1SUSP|S2SUSP|pmdisk|[zZ]*)
1216                      if [ -n "$ANYSWAP" ] ; then
1217                         einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
1218                         swapon $p 2>>$DEBUG ; eend $?
1219                      else
1220                         ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
1221                      fi
1222                      ;;
1223                    *)
1224                      if [[ "$p" == LABEL* ]] ; then
1225                         p=$(blkid -t $p | awk -F: '{print $1}')
1226                      fi
1227                      if grep -q $p /proc/swaps ; then
1228                         ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
1229                      else
1230                         if [ -b "$p" ] ; then
1231                         einfo "Using swap partition ${WHITE}${p}${NORMAL}."
1232                         swapon $p 2>>$DEBUG ; eend $?
1233                         else
1234                         ewarn "$p is not a valid block device - not using it therefore." ; eend 0
1235                         fi
1236                      fi
1237                      ;;
1238              esac # dd-check
1239           fi # -n "$NOSWAP
1240           eoutdent
1241           continue
1242           ;;
1243         esac # it's a swap partition?
1244
1245         # mount read-only
1246         MOUNTOPTS="ro"
1247         case "$f" in
1248           vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
1249           ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
1250           *) continue ;;
1251           # *) NONEFOUND='1'; continue ;;
1252         esac
1253
1254         # use a swapfile
1255         if [ -z "$NOSWAP" ] ; then
1256            mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG && MOUNTED=1 || continue
1257            # Activate swapfile, if exists
1258            SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
1259         fi
1260         if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
1261            mount -o remount,rw $m && MOUNTED=1
1262            if swapon "$SWAPFILE" 2>>$DEBUG ; then
1263               eindent
1264                 einfo "Using GRML swapfile ${WHITE}${SWAPFILE}${NORMAL}."
1265               eoutdent
1266               fnew="$SWAPFILE swap swap defaults 0 0"
1267               grep -q "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
1268               GRML_SWP="$GRML_SWP $SWAPFILE"
1269               eend 0
1270            fi
1271            mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
1272         fi
1273
1274         # use a image as home
1275         IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
1276         if [ -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
1277            if [ -n "$HOMEDIR" ]; then
1278               if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
1279                  continue
1280               fi
1281            fi
1282            if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
1283               GRML_IMG="$IMAGE"
1284               mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
1285            fi
1286         fi
1287         eend 0
1288
1289         # Umount, if not in use
1290         [ -n "$MOUNTED" ] && umount -r $m 2>/dev/null
1291
1292       done <<EOT
1293       $(cat /etc/fstab)
1294 EOT
1295    fi # -n $partitions
1296 fi # -z $INSTALLED
1297 }
1298 # }}}
1299
1300 # {{{ Mouse
1301 config_mouse(){
1302 if [ -n "$MOUSE_DEVICE" ] ; then
1303   einfo "Detecting mouse: ${MOUSE_FULLNAME} at ${MOUSE_DEVICE}" ; eend $?
1304 fi
1305 }
1306 # }}}
1307
1308 # {{{ IPv6 configuration
1309 # Load IPv6 kernel module and print IP adresses
1310 config_ipv6(){
1311 if checkbootparam 'ipv6'; then
1312   einfo "Enabling IPv6 as requested on boot commandline (sleeping for 2 seconds)"
1313   modprobe ipv6
1314   # we probably need some time until stateless autoconfiguration has happened
1315   sleep 2
1316   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1317   for DEVICE in `echo "$NETDEVICES"`; do
1318     eindent
1319       einfo "$DEVICE:"
1320       ADDRESSES="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{print $3}')"
1321       COUNT="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{ sum += 1};END {print sum }')"
1322       eindent
1323         for ADDR in `echo "$ADDRESSES"` ; do
1324             einfo "$ADDR"
1325         done
1326         if [ "$COUNT" -eq "0" ] ; then
1327            einfo "(none)" ; eend 1
1328         fi
1329       eoutdent
1330     eoutdent
1331   done
1332   eend 0
1333 fi
1334 }
1335 # }}}
1336
1337 # {{{ Fat-Client-Version: DHCP Broadcast for IP address
1338 config_dhcp(){
1339 if checkbootparam 'nodhcp'; then
1340   ewarn "Skipping DHCP broadcast/network detection as requested on boot commandline." ; eend 0
1341 else
1342   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1343   rm -rf /etc/network/status ; mkdir -p /etc/network/status
1344   for DEVICE in `echo "$NETDEVICES"` ; do
1345     einfo "Network device ${WHITE}${DEVICE}${NORMAL} detected, DHCP broadcasting for IP. (Backgrounding)"
1346     trap 2 3 11
1347     ifconfig $DEVICE up >>$DEBUG 2>&1
1348     ( pump -i $DEVICE --script=/usr/lib/grml-autoconfig/pump-runparts >>$DEBUG 2>&1 && echo finished_running_pump > /etc/network/status/$DEVICE ) &
1349     trap "" 2 3 11
1350     sleep 1
1351     eend 0
1352   done
1353   if [ -n "$INSTALLED" ] ; then
1354      ewarn 'If you want to disable automatic DHCP requests set CONFIG_DHCP=no in /etc/grml/autoconfig.'
1355      eend 0
1356   fi
1357 fi
1358 }
1359 # }}}
1360
1361 # {{{ CPU-detection
1362 config_cpu(){
1363 if checkbootparam 'nocpu'; then
1364   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
1365 else
1366   # check module dependencies
1367   cpufreq_check() {
1368    if ! [ -e /lib/modules/${KERNEL}/kernel/arch/x86/kernel/cpu/cpufreq ] ; then
1369       if [ -e /lib64 ] ; then
1370          [ -e /lib/modules/${KERNEL}/kernel/arch/x86_64/kernel/cpufreq ] || return 1
1371       else
1372          [ -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] || return 1
1373       fi
1374    fi
1375   }
1376
1377   if [[ `grep -c processor /proc/cpuinfo` -gt 1 ]] ; then
1378      einfo "Detecting CPU:"
1379      CPU=$(awk -F: '/^processor/{printf "       Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
1380      echo $CPU | sed 's/ \{1,\}/ /g'
1381      eend 0
1382   else
1383      einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
1384   fi
1385
1386   # Disclaimer: sorry for the tons of if/then/else... but this makes sure we use:
1387   # * it only if we have the according kernel modules available
1388   # * cpufreq not inside Virtual Box
1389   # * current version of /etc/init.d/loadcpufreq from Debian (to stay in sync)
1390   #   -> parse output of the initscript and output it according to our look'n'feel
1391   # * our own cpufreq-detect.sh if /etc/init.d/loadcpufreq isn't present
1392   if ! cpufreq_check ; then
1393     ewarn "Skipping cpufreq setup as module dependencies are not fulfilled." ; eend 1
1394   else
1395      # Virtual Box supports ACPI and laptop-detect would return with '0', so check for it:
1396      if [ -r /proc/acpi/battery/BAT0/info ] ; then
1397         if grep -q 'OEM info:                innotek' /proc/acpi/battery/BAT0/info ; then
1398            einfo 'Virtual Box detected, skipping cpufreq setup.' ; eend 0
1399            return 0
1400         fi
1401      fi
1402      einfo "Trying to set up cpu frequency scaling:"
1403      eindent
1404      if [ -x /etc/init.d/loadcpufreq ] ; then
1405         SKIP_CPU_GOVERNOR=''
1406         LOADCPUFREQ=$(mktemp)
1407         /etc/init.d/loadcpufreq start >"$LOADCPUFREQ" 2>&1 ; RC=$?
1408         if grep -q FATAL "$LOADCPUFREQ" ; then
1409            eindent
1410              SKIP_CPU_GOVERNOR=1
1411              oldIFS="$IFS"
1412              IFS="
1413 "
1414               for line in $(grep FATAL "$LOADCPUFREQ" | sed 's/.*FATAL: //; s/ (.*)//') ; do
1415                   eerror "$line" ; eend $RC
1416               done
1417               IFS="$oldIFS"
1418            eoutdent
1419          elif grep -q done "$LOADCPUFREQ" ; then
1420            MODULE=$(grep done "$LOADCPUFREQ" | sed 's/.*done (\(.*\))./\1/')
1421            if [ -n "$MODULE" -a "$MODULE" != none ]; then
1422               einfo "Loading cpufreq kernel module $MODULE" ; eend 0
1423            else
1424               ewarn "Could not find an appropriate kernel module for cpu frequency scaling." ; eend 1
1425            fi
1426         fi
1427         rm -f $LOADCPUFREQ
1428      elif [ -r /usr/bin/cpufreq-detect.sh ] ; then
1429         . /usr/bin/cpufreq-detect.sh
1430         if [ -n "$MODULE" -a "$MODULE" != none ]; then
1431            einfo "Loading modules ${MODULE}"
1432            modprobe "$MODULE" >>$DEBUG || modprobe "$MODULE_FALLBACK" >>$DEBUG
1433            RC=$?
1434            if [[ "$RC" == 0 ]]; then
1435               eend 0
1436            else
1437               SKIP_CPU_GOVERNOR=1
1438               eend $RC
1439            fi
1440         else
1441            ewarn "Could not detect an appropriate CPU for use with cpu frequency scaling - skipping."
1442            eend 1
1443         fi # $MODULE
1444      fi # loadcpufreq
1445
1446      if [ -z "$SKIP_CPU_GOVERNOR" ] ; then
1447         einfo "Loading cpufreq_ondemand, setting ondemand governor"
1448         RC=0
1449         if modprobe cpufreq_ondemand ; RC=$? ; then
1450            for file in $(find /sys/devices/system/cpu/ -name scaling_governor 2>/dev/null) ; do
1451                echo ondemand > $file
1452            done
1453         fi
1454         eend $RC
1455      fi # cpu-governor
1456
1457      eoutdent
1458
1459   fi # cpufreq_check
1460 fi # checkbootparam nocpu
1461 }
1462 # }}}
1463
1464 # {{{ autostart of ssh
1465 config_ssh(){
1466 if checkbootparam 'ssh' ; then
1467    SSH_PASSWD=''
1468    SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
1469    einfo "Bootoption ssh found, trying to set password for user grml."
1470    eindent
1471    if [ -z "$SSH_PASSWD" ] ; then
1472       if [ -x /usr/bin/apg ] ; then
1473          SSH_PASSWD="$(apg -M NL -a 0 -m 8 -x 12 -n 1)"
1474       elif [ -x /usr/bin/gpw ] ; then
1475          SSH_PASSWD="$(gpw 1)"
1476       elif [ -x /usr/bin/pwgen ] ; then
1477          SSH_PASSWD="$(pwgen -1 8)"
1478       elif [ -x /usr/bin/hexdump ] ; then
1479          SSH_PASSWD="$(dd if=/dev/urandom bs=14 count=1 2>/dev/null | hexdump | awk '{print $3 $4}')"
1480       elif [ -n "$RANDOM" ] ; then
1481          SSH_PASSWD="grml${RANDOM}"
1482       else
1483          SSH_PASSWD=''
1484          eerror "Empty passphrase and neither pwgen nor hexdump nor \$RANDOM found. Skipping."
1485          eend 1
1486       fi
1487
1488       if [ -n "$SSH_PASSWD" ] ; then
1489          ewarn "No given password for ssh found. Using random password: $SSH_PASSWD" ; eend 0
1490       fi
1491    fi
1492    eoutdent
1493
1494    # finally check if we have a password we can use:
1495    if [ -n "$SSH_PASSWD" ] ; then
1496       # chpasswd sucks, seriously.
1497       if chpasswd --help 2>&1 | grep -q -- '-m,' ; then
1498         echo "grml:$SSH_PASSWD" | chpasswd -m
1499       else
1500         echo "grml:$SSH_PASSWD" | chpasswd
1501       fi
1502    fi
1503
1504    einfo 'Starting secure shell server in background.'
1505    /etc/init.d/rmnologin start >>$DEBUG 2>>$DEBUG
1506    /etc/init.d/ssh start >>$DEBUG 2>>$DEBUG &
1507    eend $?
1508
1509    eindent
1510    ewarn 'Warning: please change the password for user grml as soon as possible!'
1511    eoutdent
1512 fi
1513 }
1514 # }}}
1515
1516 # {{{ autostart of x11vnc
1517 config_vnc(){
1518
1519 USER=grml # TODO: make it dynamically configurable
1520 if checkbootparam 'vnc' ; then
1521    VNC_PASSWD=''
1522    VNC_PASSWD="$(getbootparam 'vnc' 2>>$DEBUG)"
1523    einfo "Bootoption vnc found, trying to set password for user $USER."
1524    eindent
1525    if [ -z "$VNC_PASSWD" ] ; then
1526       if [ -x /usr/bin/apg ] ; then
1527          VNC_PASSWD="$(apg -M NL -a 0 -m 8 -x 12 -n 1)"
1528       elif [ -x /usr/bin/gpw ] ; then
1529          VNC_PASSWD="$(gpw 1)"
1530       elif [ -x /usr/bin/pwgen ] ; then
1531          VNC_PASSWD="$(pwgen -1 8)"
1532       elif [ -x /usr/bin/hexdump ] ; then
1533          VNC_PASSWD="$(dd if=/dev/urandom bs=14 count=1 2>/dev/null | hexdump | awk '{print $3 $4}')"
1534       elif [ -n "$RANDOM" ] ; then
1535          VNC_PASSWD="${USER}${RANDOM}"
1536       else
1537          VNC_PASSWD=''
1538          eerror "Empty passphrase and neither pwgen nor hexdump nor \$RANDOM found. Skipping."
1539          eend 1
1540       fi
1541
1542       if [ -n "$VNC_PASSWD" ] ; then
1543          ewarn "No given password for vnc found. Using random password: $VNC_PASSWD" ; eend 0
1544       fi
1545    fi
1546    eoutdent
1547
1548    # finally check if we have a password we can use:
1549    if [ -n "$VNC_PASSWD" ] ; then
1550
1551       VNCDIR="/home/${USER}/.vnc"
1552       [ -d "$VNCDIR" ] || mkdir "$VNCDIR"
1553
1554       if [ ! -x /usr/bin/x11vnc ] ; then
1555          eerror "Error: x11vnc not found - can not set up vnc. Please make sure to install the x11vnc package."
1556          eend 1
1557       else
1558          /usr/bin/x11vnc -storepasswd "$VNC_PASSWD" "$VNCDIR"/passwd ; eend $?
1559          /bin/chown -R "$USER": "$VNCDIR"
1560       fi
1561    fi
1562    if checkbootparam 'vnc_connect' ; then
1563       VNC_CONNECT=''
1564       VNC_CONNECT="$(getbootparam 'vnc_connect' 2>>$DEBUG)"
1565       einfo "Bootoption vnc_connect found, will start vnc with connect to $VNC_CONNECT."
1566       #store the options in a file
1567       VNCDIR="/home/${USER}/.vnc"
1568       [ -d "$VNCDIR" ] || mkdir "$VNCDIR"
1569       echo " --connect $VNC_CONNECT " >> $VNCDIR/options
1570    fi
1571 fi
1572 }
1573 # }}}
1574
1575 # {{{ set password for user grml
1576 config_passwd(){
1577 if checkbootparam 'passwd' >>$DEBUG 2>&1; then
1578   einfo "Bootoption passwd found."
1579   PASSWD="$(getbootparam 'passwd' 2>>$DEBUG)"
1580   if [ -n "$PASSWD" ] ; then
1581     echo "grml:$PASSWD" | chpasswd -m ; eend $?
1582   else
1583     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1584   fi
1585   eindent
1586     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1587   eoutdent
1588 fi
1589 }
1590 # }}}
1591
1592 # {{{ Check for persistent homedir option and eventually mount /home from there, or use a loopback file.
1593 config_homedir(){
1594 if checkbootparam 'home' ; then
1595    ewarn "The \"home\" bootoption is deprecated, please use the persistency feature instead."; eend 1
1596 fi
1597 }
1598 # }}}
1599
1600 # {{{ Sound
1601
1602 config_mixer(){
1603 if ! [ -x /usr/bin/amixer ] ; then
1604   eerror "amixer binary not available. Can not set sound volumes therefore." ; eend 1
1605 else
1606
1607   if ! [ -r /proc/asound/cards ] ; then
1608      ewarn "No soundcard present, skipping mixer settings therefore." ; eend 0
1609      return
1610   fi
1611
1612   if checkbootparam 'vol' ; then
1613     VOL="$(getbootparam 'vol' 2>>$DEBUG)"
1614     if [ -z "$VOL" ] ; then
1615       eerror "Bootoption vol found but no volume level/parameter given. Using defaults." ; eend 1
1616       VOL='75' # default
1617     fi
1618   else
1619     VOL='75' # default
1620   fi
1621
1622   if checkbootparam 'nosound' ; then
1623     einfo "Muting sound devices on request."
1624
1625     fix_ibm_sound 0
1626     # mute the master, this should be sufficient
1627     ERROR=$(amixer -q set Master mute)
1628     RC=$?
1629
1630     if [ -n "$ERROR" ] ; then
1631        eindent
1632        eerror "Problem muting sound devices: $ERROR"
1633        eoutdent
1634     fi
1635     eend $RC
1636   elif [ -z "$INSTALLED" ]; then
1637       einfo "Setting mixer volumes to level ${WHITE}${VOL}${NORMAL}."
1638
1639       fix_ibm_sound ${VOL}
1640
1641       # by default assume '0' as volume for microphone:
1642       if checkbootparam 'micvol' ; then
1643          MICVOL="$(getbootparam 'micvol' 2>>$DEBUG)"
1644       else
1645          MICVOL=0
1646       fi
1647
1648       # finally set the volumes:
1649       RC=0
1650       for CONTROL in Master PCM ; do
1651          amixer -q set ${CONTROL} ${VOL}%
1652          if [ $? -ne 0 ] ; then RC=$? ; fi
1653       done
1654       # dont know how to set microphone volume for all soundcards with amixer,
1655       # so use aumix instead :/
1656       if [ ${MICVOL} -ne 0 -a -x /usr/bin/aumix ] ; then
1657          aumix -m $MICVOL &>/dev/null
1658          if [ $? -ne 0 ] ; then RC=$? ; fi
1659       fi
1660
1661       eend $RC
1662   fi
1663
1664 fi
1665 }
1666
1667 # on some IBM notebooks the front control has to be toggled
1668 fix_ibm_sound() {
1669  if [ -z $1 ] ; then
1670     return
1671  fi
1672
1673  VOL=${1}
1674
1675  if [ -x /usr/bin/amixer ] ; then
1676     if amixer -q get Front >/dev/null 2>>$DEBUG ; then
1677        amixer -q set Front unmute &>/dev/null
1678        amixer -q set Front ${VOL}% &>/dev/null
1679     fi
1680  fi
1681 }
1682 # }}}
1683
1684 # {{{ modem detection
1685 config_modem(){
1686 if checkbootparam 'nomodem'; then
1687   ewarn "Skipping check for AC97 modem controller as requested on boot commandline." ; eend 0
1688 else
1689   if [ -x /etc/init.d/sl-modem-daemon ] ; then
1690      if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
1691         einfo "AC97 modem controller detected. Start it running 'Start sl-modem-daemon'."
1692         eend 0
1693      fi
1694   fi
1695 fi
1696 }
1697 # }}}
1698
1699 # {{{ keyboard add-ons
1700 config_setkeycodes(){
1701 if checkbootparam 'setkeycodes' ; then
1702  einfo "Setting keycodes as requested via bootparameter 'setkeycodes'."
1703   # MS MM keyboard add-on
1704   # fix
1705   setkeycodes e001 126 &>/dev/null
1706   setkeycodes e059 127 &>/dev/null
1707   # fn keys
1708   setkeycodes e03b 59 &>/dev/null
1709   setkeycodes e008 60 &>/dev/null
1710   setkeycodes e007 61 &>/dev/null
1711   setkeycodes e03e 62 &>/dev/null
1712   setkeycodes e03f 63 &>/dev/null
1713   setkeycodes e040 64 &>/dev/null
1714   setkeycodes e041 65 &>/dev/null
1715   setkeycodes e042 66 &>/dev/null
1716   setkeycodes e043 67 &>/dev/null
1717   setkeycodes e023 68 &>/dev/null
1718   setkeycodes e057 87 &>/dev/null
1719   setkeycodes e058 88 &>/dev/null
1720   # hp keycodes
1721   setkeycodes e00a 89 e008 90 &>/dev/null
1722  eend 0
1723 fi
1724 }
1725 # }}}
1726
1727 # {{{ wondershaper
1728 config_wondershaper(){
1729  if checkbootparam 'wondershaper' ; then
1730     WONDER="$(getbootparam 'wondershaper' 2>>$DEBUG)"
1731     CMD=wondershaper
1732     DEVICE=""
1733     DOWNSTREAM=""
1734     UPSTREAM=""
1735     if [ -n "$WONDER" ]; then
1736       # Extra options
1737       DEVICE="${WONDER%%,*}"
1738       R="${WONDER#*,}"
1739       if [ -n "$R" -a "$R" != "$WONDER" ]; then
1740         WONDER="$R"
1741         DOWNSTREAM="${WONDER%%,*}"
1742         R="${WONDER#*,}"
1743         if [ -n "$R" -a "$R" != "$WONDER" ]; then
1744           WONDER="$R"
1745           UPSTREAM="${WONDER%%,*}"
1746           R="${WONDER#*,}"
1747         fi
1748       fi
1749     fi
1750     [ -n "$DEVICE" ]     && CMD="$CMD $DEVICE"
1751     [ -n "$DOWNSTREAM" ] && CMD="$CMD $DOWNSTREAM"
1752     [ -n "$UPSTREAM" ]   && CMD="$CMD $UPSTREAM"
1753     einfo "Starting wondershaper (${CMD}) in background."
1754     ( sh -c $CMD & ) && eend 0
1755  fi
1756 }
1757 # }}}
1758
1759 # {{{ syslog-ng
1760 config_syslog(){
1761  if checkbootparam 'nosyslog'; then
1762     ewarn "Not starting syslog daemon as requested on boot commandline." ; eend 0
1763  else
1764     SYSLOGD=''
1765     [ -x /etc/init.d/syslog-ng ] && SYSLOGD='syslog-ng'
1766     [ -x /etc/init.d/rsyslog   ] && SYSLOGD='rsyslog'
1767     [ -x /etc/init.d/dsyslog   ] && SYSLOGD='dsyslog'
1768     [ -x /etc/init.d/sysklogd  ] && SYSLOGD='sysklogd'
1769     [ -x /etc/init.d/inetutils-syslogd ] && SYSLOGD='inetutils-syslogd'
1770
1771     if [ -z "$SYSLOGD" ] ; then
1772        eerror "No syslog daemon found." ; eend 1
1773     else
1774        einfo "Starting $SYSLOGD in background."
1775        /etc/init.d/$SYSLOGD start >>$DEBUG &
1776        eend 0
1777     fi
1778  fi
1779 }
1780 # }}}
1781
1782 # {{{ gpm
1783 config_gpm(){
1784  if checkbootparam 'nogpm'; then
1785   ewarn "Not starting GPM as requested on boot commandline." ; eend 0
1786  else
1787    if ! [ -r /dev/input/mice ] ; then
1788       eerror "No mouse found - not starting GPM." ; eend 1
1789    else
1790       einfo "Starting gpm in background."
1791       /etc/init.d/gpm start >>$DEBUG &
1792       # ( while [ ! -e /dev/psaux ]; do sleep 5; done; /etc/init.d/gpm start >>$DEBUG ) &
1793       eend 0
1794    fi
1795  fi
1796 }
1797 # }}}
1798
1799 # {{{ services
1800 config_services(){
1801  if checkbootparam 'services' ; then
1802     SERVICE="$(getbootparam 'services' 2>>$DEBUG)"
1803     SERVICELIST=$(echo "$SERVICE" | sed 's/,/\\n/g')
1804     SERVICENL=$(echo "$SERVICE" | sed 's/,/ /g')
1805     einfo "Starting service(s) ${SERVICENL} in background."
1806     for service in $(echo -e $SERVICELIST) ; do
1807        /etc/init.d/${service} start >>$DEBUG &
1808     done
1809     [ "$?" == "0" ] ; eend $?
1810  fi
1811 }
1812 # }}}
1813
1814 # {{{ remote files
1815 get_remote_file() {
1816   [ "$#" -eq 2 ] || ( echo "Error: wrong parameter for get_remote_file()" ; return 1 )
1817   SOURCE=$(eval echo "$1")
1818   TARGET="$2"
1819   getconfig() {
1820   wget --timeout=10 --dns-timeout=10  --connect-timeout=10 --tries=1 \
1821        --read-timeout=10 ${SOURCE} -O ${TARGET} && return 0 || return 1
1822   }
1823   einfo "Trying to get ${WHITE}${TARGET}${NORMAL}"
1824   counter=10
1825   while ! getconfig && [[ "$counter" != 0 ]] ; do
1826     echo -n "Sleeping for 1 second and trying to get config again... "
1827     counter=$(( counter-1 ))
1828     echo "$counter tries left" ; sleep 1
1829   done
1830   if [ -s "$TARGET" ] ; then
1831     einfo "Downloading was successfull." ; eend 0
1832     einfo "md5sum of ${WHITE}${TARGET}${NORMAL}: "
1833     md5sum ${TARGET} ; eend 0
1834     return 0;
1835   else
1836     einfo "Sorry, could not fetch ${SOURCE}" ; eend 1
1837     return 1;
1838  fi
1839 }
1840 # }}}
1841
1842 # {{{ config files
1843 config_netconfig(){
1844  if checkbootparam 'netconfig' ; then
1845   CONFIG="$(getbootparam 'netconfig' 2>>$DEBUG)"
1846   CONFIGFILE='/tmp/netconfig.grml'
1847
1848   if get_remote_file ${CONFIG} ${CONFIGFILE} ; then
1849     cd / && einfo "Unpacking ${WHITE}${CONFIGFILE}${NORMAL}:" && /usr/bin/unp $CONFIGFILE $EXTRACTOPTIONS ; eend $?
1850   fi
1851
1852  fi
1853 }
1854 # }}}
1855
1856 # {{{ remote scripts
1857 config_netscript() {
1858  if checkbootparam 'netscript' ; then
1859   CONFIG="$(getbootparam 'netscript' 2>>$DEBUG)"
1860   SCRIPTFILE='/tmp/netscript.grml'
1861
1862   if get_remote_file ${CONFIG} ${SCRIPTFILE} ; then
1863     chmod +x ${SCRIPTFILE}
1864     einfo "Running ${WHITE}${SCRIPTFILE}${NORMAL}:" && NETSCRIPT=${CONFIG} ${SCRIPTFILE} ; eend $?
1865   fi
1866
1867  fi
1868 }
1869 # }}}
1870
1871 # {{{ blindsound
1872 config_blindsound(){
1873  if checkbootparam 'blind' ; then
1874     beep
1875     flitewrapper "welcome to the gremel system"
1876  fi
1877 }
1878 # }}}
1879
1880 # {{{ welcome sound
1881 config_welcome(){
1882  if checkbootparam 'welcome' ; then
1883     flitewrapper "welcome to the gremel system"
1884  fi
1885 }
1886 # }}}
1887
1888 # {{{ fix/workaround for unionfs
1889 fix_unionfs(){
1890   if [ -z "$INSTALLED" ]; then
1891    touch /var/cache/apt/*cache.bin
1892   fi
1893 }
1894 # }}}
1895
1896 # {{{ create all /mnt-directories
1897 create_mnt_dirs(){
1898   ewarn "create_mnt_dirs is deprecated as grml-rebuildfstab does all we need."
1899   ewarn "Please set CONFIG_CREATE_MNT_DIRS='no' in /etc/grml/autoconfig" ; eend 0
1900 }
1901 # }}}
1902
1903 # {{{ start X window system via grml-x
1904 config_x_startup(){
1905 # make sure we start X only if startx is used *before* a nostartx option
1906 # so it's possible to disable automatic X startup using nostart
1907 if checkbootparam 'startx' && ! echo "$CMDLINE" | grep -q 'startx.*nostartx' ; then
1908  if [ -x "$(which X)" ] ; then
1909   if [ -z "$INSTALLED" ] ; then
1910    WINDOWMANAGER="$(getbootparam 'startx' 2>>$DEBUG)"
1911    if [ -z "$WINDOWMANAGER" ] ; then
1912      einfo "No window manager specified. Taking ${WHITE}wm-ng${NORMAL} as default." && eend 0
1913      WINDOWMANAGER="wm-ng"
1914    else
1915      einfo "Window manager ${WHITE}${WINDOWMANAGER}${NORMAL} found as bootoption." && eend 0
1916    fi
1917    einfo "Setting up and invoking grml-x ${WINDOWMANAGER}. Just exit X windows system to get full featured consoles."
1918    config_userfstab || fstabuser='grml'
1919  cat>|/etc/init.d/xstartup<<EOF
1920 #!/bin/sh
1921 su $fstabuser -c "/usr/bin/grml-x $WINDOWMANAGER"
1922 EOF
1923    chmod 755 /etc/init.d/xstartup
1924
1925    # adjust inittab for xstartup
1926    if grep -q '^6:' /etc/inittab ; then
1927       sed -i 's|^6:.*|6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /usr/bin/zsh-login" >/dev/tty6 2>\&1 </dev/tty6|' /etc/inittab
1928    else # just append tty6 to inittab if no definition is present:
1929       echo '6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /usr/bin/zsh-login" >/dev/tty6 2>&1 < /dev/tty6' >> /etc/inittab
1930    fi
1931
1932    /sbin/telinit q ; eend $?
1933
1934    if grep -q '^allowed_users=' /etc/X11/Xwrapper.config ; then
1935       sed -i 's/^allowed_users=.*/allowed_users=anybody/' /etc/X11/Xwrapper.config
1936    else
1937       echo 'allowed_users=anybody' >> /etc/X11/Xwrapper.config
1938    fi
1939
1940   else
1941     eerror "We are not running in live mode - startx will not work, skipping it."
1942     eerror " -> Please use something like xdm, gdm or kdm for starting X on a harddisk system!" ; eend 1
1943   fi
1944  else
1945    eerror "/usr/X11R6/bin/X is not present on this grml flavour."
1946    eerror "  -> Boot parameter startx does not work therefore." ; eend 1
1947  fi
1948 fi
1949 }
1950 # }}}
1951
1952 # {{{ configuration framework
1953 config_extract(){
1954 if checkbootparam 'extract' ; then
1955  EXTRACT="$(getbootparam 'extract' 2>>$DEBUG)"
1956  EXTRACTOPTIONS="-- -x $EXTRACT"
1957 fi
1958 }
1959
1960 config_finddcsdir() {
1961 #  - If no GRMLCFG partition is found and noautoconfig is _not_ given
1962 #    on the command line, nothing is changed and the dcs files are
1963 #    searched within the .iso, $dcs-dir is set to the root directory
1964 #    within the .iso
1965 #  - If a GRMLCFG partition is found, $dcs-dir is set to the root of
1966 #    the GRMLCFG partition unless noautoconfig is set. If noautoconfig is
1967 #    set, $dcs-dir is set to the root directory within the .iso.
1968 #  - If myconfig=foo is set on the command line, $dcs-dir is set to
1969 #    foo, even if a GRMLCFG partition is present.
1970 DCSDIR=""
1971 DCSMP="/mnt/grml"
1972 if checkbootparam 'noautoconfig' || checkbootparam 'forensic' ; then
1973   ewarn "Skipping running automount of device(s) labeled GRMLCFG as requested." ; eend 0
1974 else
1975   if [ -z "$INSTALLED" ] ; then
1976     if checkbootparam 'myconfig' ; then
1977       DCSDEVICE="$(getbootparam 'myconfig' 2>>$DEBUG)"
1978       if [ -z "$DCSDEVICE" ]; then
1979         eerror "Error: No device for bootoption myconfig provided." ; eend 1
1980       fi # [ -z "$DCSDEVICE" ]
1981     elif checkvalue $CONFIG_MYCONFIG; then # checkbootparam myconfig
1982       einfo "Searching for device(s) labeled with GRMLCFG. (Disable this via boot option: noautoconfig)" ; eend 0
1983       eindent
1984       # We do need the following fix so floppy disk is available to blkid in any case :-/
1985       if [ -r /dev/fd0 ] ; then
1986         einfo "Floppy device detected. Trying to access floppy disk."
1987         if timeout 4 dd if=/dev/fd0 of=/dev/null bs=512 count=1 >>$DEBUG 2>&1 ; then
1988            blkid /dev/fd0 >>$DEBUG 2>&1
1989         fi
1990       fi
1991       DCSDEVICE=$(blkid -t LABEL=GRMLCFG | head -1 | awk -F: '{print $1}')
1992       if [ -n "$DCSDEVICE" ]; then
1993         DCSMP="/mnt/grmlcfg"
1994       fi
1995       eoutdent
1996     fi
1997
1998     # if not specified/present then assume default:
1999     if [ -z "$DCSDEVICE" ]; then
2000       DCSDIR="/live/image"
2001     else
2002       eindent
2003       einfo "debs, config, scripts are read from $DCSDEVICE." ; eend 0
2004       DCSDIR="$(< /proc/mounts awk -v DCSDEV=$DCSDEVICE '{if ($1 == DCSDEV) { print $2 }}')"
2005       if [ -n "$DCSDIR" ]; then
2006         ewarn "$DCSDEVICE already mounted on $DCSDIR"; eend 0
2007       else
2008         [ -d $DCSMP ] || mkdir $DCSMP
2009         umount $DCSMP >>$DEBUG 2>&1 # make sure it is not mounted
2010         mount -o ro -t auto $DCSDEVICE  $DCSMP ; RC="$?"
2011         if [[ $RC == 0 ]]; then
2012           einfo "Successfully mounted $DCSDEVICE to $DCSMP (readonly)." ; eend 0
2013         else
2014           eerror "Error: mounting $DCSDEVICE to $DCSMP (readonly) failed." ; eend 1
2015         fi
2016         DCSDIR="$DCSMP"
2017       fi
2018       eoutdent
2019     fi
2020   fi
2021 fi
2022
2023 if [ -n "$DCSDIR" -a "$DCSDIR" != "/live/image" ] ; then
2024   einfo "Debs, config, scripts (if present) will be read from $DCSDIR." ; eend 0
2025 elif checkbootparam 'debs' || checkbootparam 'config' || checkbootparam 'scripts'; then
2026   einfo "Debs, config, scripts will be read from the live image directly." ; eend 0
2027 fi
2028 }
2029
2030
2031 config_partconf() {
2032 if checkbootparam 'partconf' ; then
2033  MOUNTDEVICE="$(getbootparam 'partconf' 2>>$DEBUG)"
2034  if [ -n "$MOUNTDEVICE" ]; then
2035    [ -d /mnt/grml ] || mkdir /mnt/grml
2036    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
2037     if [[ $RC == 0 ]]; then
2038       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
2039       einfo "Copying files from $MOUNTDEVICE over grml system."
2040       for file in `cat /etc/grml/partconf` ; do
2041         [ -d /mnt/grml/$file ] && cp -a /mnt/grml/${file}* ${file} && echo "copied: $file"
2042         [ -f /mnt/grml/$file ] && cp -a /mnt/grml/${file}  ${file} && echo "copied: $file"
2043       done && eend 0
2044     else
2045       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
2046     fi # mount $MOUNTDEVICE
2047    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
2048  else
2049    einfo "Sorry, no device for bootoption partconf provided. Skipping." ; eend 1
2050  fi # [ -n "$MOUNTDEVICE" ]
2051 fi
2052 }
2053 # }}}
2054
2055 # {{{ /cdrom/.*-options
2056 config_debs(){
2057 if checkbootparam 'debs' ; then
2058    iszsh && setopt localoptions shwordsplit
2059    DEBS="$(getbootparam 'debs' 2>>$DEBUG)"
2060    if ! echo $DEBS | grep -q '/'; then
2061      # backwards compatibility: if no path is given get debs from debs/
2062      DEBS="debs/$DEBS"
2063    fi
2064    einfo "Tring to install debian package(s) ${DEBS}"
2065    DEBS="$(eval echo ${DCSDIR}/$DEBS)"
2066    dpkg -i $DEBS ; eend $?
2067 fi
2068 }
2069
2070 config_scripts(){
2071 if checkbootparam 'scripts' || [ "$DCSMP" = "/mnt/grmlcfg" ]; then
2072    SCRIPTS="$(getbootparam 'scripts' 2>>$DEBUG)"
2073    if [ -d ${DCSDIR}/scripts ] && [ -z "$SCRIPTS" ]; then
2074      SCRIPTS="$(cd ${DCSDIR}/scripts; /bin/ls -1d [Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
2075    fi
2076    if ! echo $SCRIPTS | grep -q '/'; then
2077      # backwards compatibility: if no path is given get scripts from scripts/
2078      SCRIPTS="scripts/$SCRIPTS"
2079    fi
2080    if [ "$DCSMP" = "/mnt/grmlcfg" ]; then
2081      # we are executing from a GRMLCFG labeled fs
2082      # kick everything we have done before and start over
2083      SCRIPTS="$(cd ${DCSDIR}; /bin/ls -1d [Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
2084    fi
2085    if [ -n "$SCRIPTS" ]; then
2086      SCRIPTS="${DCSDIR}/$SCRIPTS"
2087      if [ "$DCSMP" = "/mnt/grmlcfg" ]; then
2088        einfo "Trying to execute ${SCRIPTS}"
2089        sh -c $SCRIPTS
2090      elif [ -d "$SCRIPTS" ]; then
2091        einfo "Bootparameter scripts found. Trying to execute from directory ${SCRIPTS}:"
2092        run-parts $SCRIPTS
2093      else
2094        einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
2095        sh -c $SCRIPTS
2096      fi
2097    fi
2098 fi
2099 }
2100
2101 config_config(){
2102 if checkbootparam 'config' || [ "$DCSMP" = "/mnt/grmlcfg" ]; then
2103   CONFIG="$(getbootparam 'config' 2>>$DEBUG)"
2104   if [ -z "$CONFIG" ]; then
2105     CONFIG="$(cd ${DCSDIR}; ls -1d [Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
2106   fi
2107   if [ -n "$CONFIG" ]; then
2108     if [ -d "${DCSDIR}/${CONFIG}" ] ; then
2109       einfo "Taking configuration from directory ${DCSDIR}/${CONFIG}"
2110
2111       cp -a ${DCSDIR}/${CONFIG}/* /
2112     elif [ -f "${DCSDIR}/${CONFIG}" ]; then
2113       einfo "Extracting configuration from file ${DCSDIR}/${CONFIG}"
2114
2115       cd /
2116       unp ${DCSDIR}/${CONFIG} $EXTRACTOPTIONS ; eend $?
2117     else
2118       ewarn "Sorry, could not find configuration file or directory ${DCSDIR}/${FILENAME}." ; eend 1
2119     fi
2120   fi
2121 fi
2122 # umount $DCSMP if it was mounted by finddcsdir
2123 # this doesn't really belong here
2124 grep -q '$DCSMP' /proc/mounts && umount $DCSMP
2125 }
2126 # }}}
2127
2128 # {{{ mypath
2129 config_mypath(){
2130 if checkbootparam 'mypath' ; then
2131    MY_PATH="$(getbootparam 'mypath' 2>>$DEBUG)"
2132    einfo "Bootparameter mypath found, adding ${MY_PATH} to /etc/grml/my_path"
2133    touch /etc/grml/my_path
2134    chmod 644 /etc/grml/my_path
2135    # make sure the directories exist:
2136    eindent
2137    for i in $(echo $MY_PATH | sed 's/:/\n/g') ; do
2138        if ! [ -d "$i" ] ; then
2139           einfo "Creating directory $i"
2140           mkdir -p "$i" ; eend $?
2141        fi
2142    done
2143    grep -q "${MY_PATH}" /etc/grml/my_path || echo "${MY_PATH}" >> /etc/grml/my_path ; eend $?
2144    eoutdent
2145 fi
2146 }
2147 # }}}
2148
2149 # {{{ distcc
2150 config_distcc(){
2151 if checkbootparam 'distcc' ; then
2152  OPTIONS="$(getbootparam 'distcc' 2>>$DEBUG)"
2153  if [ -n "$OPTIONS" ]; then
2154     NET=""
2155     INTERFACE=""
2156     if [ -n "$OPTIONS" ]; then
2157       NET="${OPTIONS%%,*}"
2158       R="${OPTIONS#*,}"
2159       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2160         OPTIONS="$R"
2161         INTERFACE="${OPTIONS%%,*}"
2162         R="${OPTIONS#*,}"
2163       fi
2164     fi
2165  fi
2166  CONFIG=/etc/default/distcc
2167  sed -i "s#^STARTDISTCC=.*#STARTDISTCC=YES#"  $CONFIG
2168  sed -i "s#^ALLOWEDNETS=.*#ALLOWEDNETS=$NET#" $CONFIG
2169
2170  if [ -n "$INTERFACE" ] ; then
2171    IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
2172
2173    counter=10
2174    while [ -z "$IP" ] && [[ "$counter" != 0 ]] ; do
2175      counter=$(( counter-1 ))
2176      ewarn "No ip address for $INTERFACE found. Sleeping for 3 seconds. $counter tries left."
2177      sleep 3
2178      IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
2179    done
2180  fi
2181
2182  if [ -n "$IP" ] ; then
2183    sed -i "s#^LISTENER=.*#LISTENER=$IP#"      $CONFIG
2184
2185    einfo "Bootoption distcc found. Preparing setup for distcc daemon."
2186    eindent
2187     id distccd >/dev/null 2>&1 || \
2188     (
2189       einfo "Creating distcc user" ; \
2190       adduser --quiet --system --ingroup nogroup --home / --no-create-home distccd ; eend $?
2191     )
2192
2193     einfo "Starting distcc for network ${NET}, listening on ${IP}."
2194    /etc/init.d/distcc start >/dev/null ; eend $?
2195    eoutdent
2196  else
2197    eerror "No ip address for $INTERFACE found. distcc can not be used without it." ; eend 1
2198  fi
2199 fi
2200
2201 if checkbootparam 'gcc'; then
2202  GCC="$(getbootparam 'gcc' 2>>$DEBUG)"
2203  eindent
2204  einfo "Pointing /usr/bin/gcc to /usr/bin/gcc-${GCC}."
2205  eoutdent
2206  rm -f /usr/bin/gcc
2207  ln -s /usr/bin/gcc-${GCC} /usr/bin/gcc ; eend $?
2208 fi
2209
2210 if checkbootparam 'gpp'; then
2211  GPP="$(getbootparam 'gpp' 2>>$DEBUG)"
2212  eindent
2213   einfo "Pointing /usr/bin/g++ to /usr/bin/g++-${GPP}."
2214   if [ -x /usr/bin/g++-${GPP} ] ; then
2215      rm -f /usr/bin/g++
2216      ln -s /usr/bin/g++-${GPP} /usr/bin/g++ ; eend $?
2217   fi
2218   einfo "Pointing /usr/bin/cpp to /usr/bin/cpp-${GPP}."
2219   if [ -x /usr/bin/cpp-${GPP} ] ; then
2220      rm -f /usr/bin/cpp
2221      ln -s /usr/bin/cpp-${GPP} /usr/bin/cpp ; eend $?
2222   fi
2223  eoutdent
2224 fi
2225
2226 }
2227 # }}}
2228
2229 # {{{ load modules
2230 # Notice: use it only on live-cd system, if running from harddisk please
2231 # add modules to /etc/modules and activate /etc/init.d/module-init-tools
2232 # in /etc/runlevel.conf
2233 config_modules(){
2234 MODULES_FILE=/etc/grml/modules
2235 if checkbootparam 'nomodules' ; then
2236   ewarn "Skipping loading of modules defined in ${MODULES_FILE} as requested." ; eend 0
2237 elif [ -z "$INSTALLED" ]; then
2238  if [ -r $MODULES_FILE ] ; then
2239   einfo "Loading modules specified in ${MODULES_FILE}:"
2240   eindent
2241   grep '^[^#]' $MODULES_FILE | \
2242   while read module args; do
2243     [ "$module" ] || continue
2244       einfo "${module}"
2245       modprobe $module $args ; eend $?
2246   done
2247   eoutdent
2248  else
2249   ewarn "File $MODULES_FILE does not exist. Skipping loading of specific modules." ; eend 1
2250  fi
2251 fi
2252 }
2253 # }}}
2254
2255 # {{{ 915resolution
2256 config_915resolution(){
2257 if checkbootparam '915resolution' ; then
2258  OPTIONS="$(getbootparam '915resolution' 2>>$DEBUG)"
2259   if [ -x /usr/sbin/915resolution ]; then
2260     CMD=915resolution
2261     MODE=""
2262     XRESO=""
2263     YRESO=""
2264     if [ -n "$OPTIONS" ]; then
2265       # Extra options
2266       MODE="${OPTIONS%%,*}"
2267       R="${OPTIONS#*,}"
2268       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2269         OPTIONS="$R"
2270         XRESO="${OPTIONS%%,*}"
2271         R="${OPTIONS#*,}"
2272         if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2273           OPTIONS="$R"
2274           YRESO="${OPTIONS%%,*}"
2275           R="${OPTIONS#*,}"
2276         fi
2277       fi
2278     fi
2279     einfo "Running 915resolution with options ${MODE} ${XRESO} ${YRESO}."
2280     [ -n "$MODE" ] && [ -n "$XRESO"  ] && [ -n "$YRESO" ]  && ( sh -c "$CMD $MODE $XRESO $YRESO" & )
2281     eend 0
2282   fi
2283 fi
2284 }
2285 # }}}
2286
2287 # {{{ SW-RAID
2288 config_swraid(){
2289   [ -n "$INSTALLED" ] && return 0
2290
2291   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
2292   if checkbootparam 'noraid'   || checkbootparam 'noswraid' || \
2293      checkbootparam 'forensic' || checkbootparam 'raid=noautodetect' ; then
2294      ewarn "Skipping SW-RAID code as requested on boot commandline." ; eend 0
2295   else
2296     if ! [ -x /sbin/mdadm ] ; then
2297        eerror "mdadm not available, can not execute it." ; eend 1
2298     else
2299
2300        # if ! egrep -qv '^(MAILADDR.*|#.*|)$' /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
2301        # find out whether we have a valid configuration file already
2302        if ! grep -q ARRAY /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
2303           einfo "Creating /etc/mdadm/mdadm.conf for use with mdadm."
2304           [ -r /etc/mdadm/mdadm.conf ] && mv /etc/mdadm/mdadm.conf /etc/mdadm/mdadm.conf.old
2305           MDADM_MAILADDR__='root' /usr/share/mdadm/mkconf > /etc/mdadm/mdadm.conf ; eend $?
2306         else
2307           ewarn "/etc/mdadm/mdadm.conf looks like a configured mdadm setup, will not touch it." ; eend 0
2308        fi
2309
2310        if ! checkbootparam 'swraid' ; then
2311           eindent
2312           einfo "Just run 'Start mdadm-raid' to assemble md arrays or boot using 'swraid' as bootoption for autostart."
2313           eoutdent
2314        else
2315           einfo "Bootoption swraid found. Searching for software RAID arrays:"
2316           eindent
2317            IFSOLD=${IFS:-}
2318            IFS='
2319 '
2320            for line in $(mdadm --assemble --scan --auto=yes --symlink=no 2>&1) ; do
2321                case $line in
2322                  *'No arrays found'*)
2323                    ewarn "$line" ; eend 0
2324                    ;;
2325                  *)
2326                    einfo "$line" ; eend 0
2327                    ;;
2328                esac
2329            done
2330            IFS=$IFSOLD
2331          eoutdent
2332
2333          if [ -r /proc/mdstat ] ; then
2334             eindent
2335             MDSTAT=$(grep '^md[0-9]' /proc/mdstat)
2336             if [ -z "$MDSTAT" ] ; then
2337                ewarn "No active arrays found" ; eend 0
2338             else
2339                IFSOLD=${IFS:-}
2340                IFS='
2341 '
2342                for line in $(grep '^md[0-9]' /proc/mdstat) ; do
2343                    einfo "active arrays: $line" ; eend 0
2344                done
2345                IFS=$IFSOLD
2346             fi
2347             eoutdent
2348          fi # /proc/mdstat
2349        fi # bootoption swraid
2350
2351      fi # is /sbin/mdadm executable?
2352   fi # check for bootoptions
2353 }
2354 # }}}
2355
2356 # {{{ dmraid
2357 config_dmraid(){
2358   [ -n "$INSTALLED" ] && return 0
2359
2360   if checkbootparam 'nodmraid' ; then
2361     ewarn "Skipping dmraid code as requested on boot commandline." ; eend 0
2362     return 0
2363   fi
2364
2365   if ! [ -x /sbin/dmraid ] ; then
2366     eerror "dmraid not available, can not execute it." ; eend 1
2367     return
2368   fi
2369
2370   dmraid_wrapper() {
2371     # usage: dmraid_wrapper <dmraid_option>
2372     [ -n "$1" ] || return 1
2373
2374     IFSOLD=${IFS:-}
2375     IFS='
2376 '
2377     eindent
2378
2379     for line in $(dmraid $1 ; echo errcode:$?); do
2380       case $line in
2381         *'no block devices found'*)
2382           einfo "No block devices found" ; eend 0
2383           break
2384           ;;
2385         *'no raid disks'*)
2386           einfo "No active dmraid devices found" ; eend 0
2387           break
2388           ;;
2389         errcode:0)
2390           eend 0;
2391           ;;
2392         errcode:1)
2393           eend 1
2394           ;;
2395         *)
2396           einfo "$line"
2397           ;;
2398       esac
2399     done
2400
2401     eoutdent
2402     IFS=$IFSOLD
2403   }
2404
2405   if checkbootparam 'dmraid' ; then
2406     local ACTION="$(getbootparam 'dmraid' 2>>$DEBUG)"
2407     if [ "$ACTION" = "off" ] ; then
2408       # Deactivates all active software RAID sets:
2409       einfo "Deactivating present dmraid sets (as requested via dmraid=off):"
2410       dmraid_wrapper -an
2411     else
2412       # Activate all software RAID sets discovered:
2413       einfo "Activating present dmraid sets (as requested via dmraid):"
2414       dmraid_wrapper -ay
2415     fi
2416
2417     return
2418   fi
2419
2420   # by default (no special bootoptions) discover all software RAID devices:
2421   einfo "Searching for any present dmraid sets:"
2422   dmraid_wrapper -r
2423 }
2424 # }}}
2425
2426 # {{{ LVM (Logical Volumes)
2427 config_lvm(){
2428   [ -n "$INSTALLED" ] && return 0
2429
2430   if checkbootparam 'nolvm' ; then
2431      ewarn "Skipping LVM code as requested on boot commandline." ; eend 0
2432   else
2433     # Debian etch provides /etc/init.d/lvm only, newer suites provide /etc/init.d/lvm2
2434     if ! [ -x /sbin/lvm -a -x /sbin/lvdisplay ] || ! [ -x /etc/init.d/lvm2 -o -x /etc/init.d/lvm ] ; then
2435        eerror "LVM not available, can not execute it." ; eend 1
2436     else
2437        if lvdisplay 2>&1 | grep -v 'No volume groups found' >/dev/null 2>&1 ; then
2438           einfo "You seem to have logical volumes (LVM) on your system."
2439           eindent
2440           einfo "Just run 'Start lvm2' to activate them or boot using 'lvm' as bootoption for autostart."
2441           eend 0
2442           if checkbootparam 'lvm' ; then
2443              einfo "Bootoption LVM found. Searching for logical volumes:"
2444              /etc/init.d/lvm2 start ; eend $?
2445           fi
2446           eoutdent
2447        fi
2448     fi # check for lvm binary
2449   fi # check for bootoption nolvm
2450 }
2451 # }}}
2452
2453 # {{{ debnet: setup network based on an existing one found on a partition
2454 config_debnet(){
2455 if checkbootparam 'debnet' ; then
2456  iszsh && setopt localoptions shwordsplit
2457  DEVICES="$(< /proc/partitions tail -n +3 | awk '{print "/dev/"$4}' | tr "\n" " ")"
2458  DEVICES="$DEVICES $(ls /dev/mapper/*)"
2459  FOUND_DEBNET=""
2460
2461  einfo "Bootoption 'debnet' found. Searching for Debian network configuration: "
2462  eindent
2463  if ! mount | grep '/mnt ' >/dev/null 2>&1 ; then
2464     for i in $DEVICES; do
2465      if mount -o ro -t auto "$i" /mnt >/dev/null 2>&1; then
2466          einfo "Scanning on $i"
2467        if [ -f /mnt/etc/network/interfaces ]; then
2468          einfo "/etc/network/interfaces found on ${i}" ; eend 0
2469          FOUND_DEBNET="$i"
2470          break
2471        fi
2472        umount /mnt
2473      fi
2474     done
2475
2476    if [ -n "$FOUND_DEBNET" ]; then
2477      einfo "Stopping network."
2478        pump -k >/dev/null 2>&1
2479        /etc/init.d/networking stop >/dev/null 2>&1 ; eend $?
2480      einfo "Copying Debian network configuration from $FOUND_DEBNET to running system."
2481        rm -rf /etc/network/run
2482        cp -a /mnt/etc/network /etc
2483        rm -rf /etc/network/run
2484        mkdir /etc/network/run
2485        umount /mnt ; eend $?
2486      einfo "Starting network."
2487        invoke-rc.d networking start ; eend $?
2488    else
2489      eerror "/etc/network/interfaces not found." ; eend 1
2490    fi
2491    eoutdent
2492  else
2493   eerror "Error: /mnt already mounted." ; eend 1
2494  fi
2495 fi
2496 }
2497 # }}}
2498
2499 # {{{ check for broken ipw3945 driver which causes problems (especially on hd install)
2500 config_ipw3945() {
2501   if grep -q ipw3945 /proc/modules ; then
2502      if ! iwconfig 2>/dev/null| grep -qe 'IEEE 802' -qe 'unassociated' ; then
2503         ewarn "Broken ipw3945 network interface found, reloading module."
2504         rmmod ipw3945
2505         modprobe ipw3945
2506         eend $?
2507      fi
2508   fi
2509 }
2510 # }}}
2511
2512 # {{{ disable console blanking
2513 config_blanking(){
2514 if checkbootparam 'noblank' ; then
2515   einfo "Bootoption noblank found. Disabling monitor blanking."
2516   setterm -blank 0 ; eend $?
2517 fi
2518 }
2519 # }}}
2520
2521 # {{{ tohd= bootoption
2522 config_tohd()
2523 {
2524   if checkbootparam 'tohd' ; then
2525      local TARGET="$(getbootparam 'tohd' 2>>$DEBUG)"
2526      if [ -z "$TARGET" ] ; then
2527         eerror "Error: tohd specified without any partition, can not continue." ; eend 1
2528         eerror "Please use something like tohd=/dev/sda9." ; eend 1
2529         return 1
2530      fi
2531
2532      if ! [ -b "$TARGET" ] ; then
2533         eerror "Error: $TARGET is not a valid block device, sorry." ; eend 1
2534         return 1
2535      fi
2536
2537      if grep -q $TARGET /proc/mounts ; then
2538         eerror "$TARGET already mounted, skipping execution of tohd therefore."
2539         eend 1
2540         return 1
2541      fi
2542
2543      local MOUNTDIR=$(mktemp -d)
2544
2545      if mount -o rw "$TARGET" "$MOUNTDIR" ; then
2546         einfo "Copyring live system to $TARGET - this might take a while"
2547         rsync -a --progress /live/image/live $MOUNTDIR
2548         sync
2549         umount "$MOUNTDIR"
2550         eend $?
2551         einfo "Booting with \"grml bootfrom=$TARGET\" should work now." ; eend 0
2552      else
2553         eerror "Error when trying to mount $TARGET, sorry."; eend 1
2554         return 1
2555      fi
2556
2557      rmdir "$MOUNTDIR"
2558   fi
2559 }
2560 # }}}
2561
2562 # {{{ grml2hd: automatic installation
2563 config_grml2hd(){
2564
2565 if checkbootparam "BOOT_IMAGE=grml2hd" ; then
2566
2567 if checkbootparam 'user' ; then
2568    NEWUSER=''
2569    NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
2570    sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2571 fi
2572
2573 if checkbootparam 'filesystem' ; then
2574    FILESYSTEM=''
2575    FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
2576    sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2577 fi
2578
2579 if checkbootparam 'partition' ; then
2580    PARTITION=''
2581    PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
2582    # notice: the following checks whether the given partition is available, if not the skip
2583    # execution of grml2hd as it might result in data loss...
2584    if [ -r $PARTITION ] ; then
2585       sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2586    else
2587       ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
2588    fi
2589 fi
2590
2591 if checkbootparam 'mbr' ; then
2592    BOOT_PARTITION=''
2593    BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
2594    sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2595 fi
2596
2597 cat>|/usr/bin/grml2hd_noninteractive<<EOF
2598 #!/bin/sh
2599 GRML2HD_NONINTERACTIVE='yes' grml2hd
2600 EOF
2601
2602 chmod 755 /usr/bin/grml2hd_noninteractive
2603 einfo "Bootoption grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
2604 if [ -z "$GRML2HD_FAIL" ] ; then
2605    screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
2606 else
2607    ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
2608 fi
2609
2610 fi # if checkbootparam "BOOT_IMAGE=grml2hd ...
2611 }
2612 # }}}
2613
2614 # {{{ debootstrap: automatic installation
2615 config_debootstrap(){
2616
2617 if checkbootparam "BOOT_IMAGE=debian2hd" ; then
2618
2619 einfo "Bootoption debian2hd found. Setting up environment for automatic installation via grml-debootstrap." ; eend 0
2620
2621 if ! [ -x /usr/sbin/grml-debootstrap ] ; then
2622    eindent
2623    eerror "Bootoption debian2hd found, but grml-debootstrap is not available." ; eend 1
2624    eoutdent
2625    exit 1
2626 fi
2627
2628 if checkbootparam 'target' ; then
2629   TARGET=''
2630   TARGET="$(getbootparam 'target' 2>>$DEBUG)"
2631   # notice: the following checks whether the given partition is available, if not the skip
2632   # execution of grml-debootstrap as it might result in data loss...
2633   if ! [ -r "$TARGET" ] ; then
2634      eerror "Target $TARGET does not exist. Skipping execution of grml-debootstrap therefore." ; eend 1
2635   fi
2636 else
2637   eindent
2638   eerror "No bootoption named target found, can not continue execution of grml-debootstrap." ; eend 1
2639   eoutdent
2640   exit 1
2641 fi
2642
2643 if checkbootparam 'grub' ; then
2644   GRUB=''
2645   GRUB="$(getbootparam 'grub' 2>>$DEBUG)"
2646 fi
2647
2648 if checkbootparam 'groot' ; then
2649   GROOT=''
2650   GROOT="$(getbootparam 'groot' 2>>$DEBUG)"
2651 fi
2652
2653 if checkbootparam 'release' ; then
2654   RELEASE=''
2655   RELEASE="$(getbootparam 'release' 2>>$DEBUG)"
2656 fi
2657
2658 if checkbootparam 'mirror' ; then
2659   MIRROR=''
2660   MIRROR="$(getbootparam 'mirror' 2>>$DEBUG)"
2661 fi
2662
2663 if checkbootparam 'boot_append' ; then
2664   BOOT_APPEND=''
2665   BOOT_APPEND="$(getbootparam 'boot_append' 2>>$DEBUG)"
2666 fi
2667
2668 if checkbootparam 'password' ; then
2669   PASSWORD=''
2670   PASSWORD="$(getbootparam 'password' 2>>$DEBUG)"
2671 fi
2672
2673 # now check which options are available
2674 if [ -n "TARGET" ] ; then
2675    TARGETCMD="--target $TARGET"
2676 else
2677    TARGETCMD=''
2678    eindent
2679    eerror "Target not set via bootoption. Skipping execution of grml-debootstrap therefore."; eend 1
2680    eoutdent
2681    exit 1
2682 fi
2683 [ -n "$GRUB" ]     && GRUBCMD="--grub $GRUB"               || GRUBCMD=''
2684 [ -n "$GROOT" ]    && GROOTCMD="--groot $GROOT"            || GROOTCMD=''
2685 [ -n "$RELEASE" ]  && RELEASECMD="--release $RELEASE"      || RELEASECMD=''
2686 [ -n "$MIRROR" ]   && MIRRORCMD="--mirror $MIRROR"         || MIRRORCMD=''
2687 [ -n "$PASSWORD" ] && PASSWORDCMD="--password $PASSWORD"   || PASSWORDCMD=''
2688 [ -n "$BOOT_APPEND" ] && BOOT_APPEND="--boot_append $BOOT_APPEND" || BOOT_APPEND=''
2689
2690 # and finally write script and execute it
2691 cat>|/usr/bin/grml-debootstrap_noninteractive<<EOF
2692 #!/bin/sh
2693 AUTOINSTALL='yes' grml-debootstrap $TARGETCMD $GRUBCMD $GROOTCMD $RELEASECMD $MIRRORCMD $PASSWORDCMD $BOOT_APPEND
2694 EOF
2695
2696 chmod 750  /usr/bin/grml-debootstrap_noninteractive
2697
2698 screen /usr/bin/grml-debootstrap_noninteractive
2699 einfo "Invoking a shell, just exit to continue booting..."
2700 /bin/zsh
2701
2702 fi # checkbootparam "BOOT_IMAGE=debian2hd
2703 }
2704 # }}}
2705
2706 # {{{ Support customization
2707 config_distri(){
2708 if checkbootparam 'distri'; then
2709   DISTRI="$(getbootparam 'distri' 2>>$DEBUG)"
2710   if [ -r "${LIVECD_PATH}"/desktop/"$DISTRI".jpg ] ; then
2711      [ -n "$BOOTDEBUG" ] && einfo "Debug: bootoption distri found and file ${LIVECD_PATH}/desktop/${DISTRI} present" && eend 0
2712      # make sure the desktop.jpg file is not a symlink, so copying does not file then
2713      [ -L /usr/share/grml/desktop.jpg ] && rm /usr/share/grml/desktop.jpg
2714      cp "${LIVECD_PATH}"/desktop/"$DISTRI".jpg /usr/share/grml/desktop.jpg
2715   fi
2716 fi
2717 }
2718 # }}}
2719
2720 ### {{{ backwards compatible stuff
2721 config_environment(){
2722   ewarn "config_environment is deprecated. Please set CONFIG_ENVIRONMENT in /etc/grml/autoconfig to 'no'." ; eend 0
2723 }
2724 config_keyboard(){
2725   ewarn "config_keyboard is deprecated. Please set CONFIG_KEYBOARD in /etc/grml/autoconfig to 'no'." ; eend 0
2726 }
2727 # }}}
2728
2729 ## END OF FILE #################################################################
2730 # vim:foldmethod=marker expandtab ai ft=zsh shiftwidth=3